$Id: History 90578 2015-06-04 09:55:07Z gcosmo $
-------------------------------------------------------------------

     =========================================================
     Geant4 - an Object-Oriented Toolkit for Simulation in HEP
     =========================================================

                      Category History file
                      ---------------------
This file should be used by G4 developers and category coordinators
to briefly summarize all major modifications introduced in the code
and keep track of all category-tags.
It DOES NOT substitute the  CVS log-message one should put at every
committal in the CVS repository !

     ----------------------------------------------------------
     * Reverse chronological order (last date on top), please *
     ----------------------------------------------------------

30.04.2015 V. Ivanchenko, tag emlowen-V10-00-24
           - G4EMDataSet - fixed Coverity warnings
           - G4LivermorePhotoElectricModel - implement the same protection as in
               standard model to avoid rare precision lost in de-excitation

05.12.2014 G. Cosmo, tag emlowen-V10-00-23
           - Corrected sources.cmake to include missing files:
             G4hSRIM2000p.hh
             G4hSRIM2000p.cc

14.11.2014 G4MicroElecInelasticModel from M. Raine, tag emlowen-V10-00-22
           - fix of loop

31.10.2014 G4MicroElecInelasticModel from M. Raine, tag emlowen-V10-00-21
           -change in angular generator, to use G4DeltaAngle model

28.10.2014 G4MicroElecInelastic and G4MicroElecInelasticModel from M. Raine, tag emlowen-V10-00-20
           - better treatment of GenericIon
           - MT compatibility improved

22.10.2014 M. Karamitros (committer), M.Raine (author), tag emlowen-V10-00-19
	   G4MicroElecElasticModel from M. Raine:
	   - uses cumulated cross-sections
           - MT compatibility improved
           - uses LinLinInterpolate instead of LinLog
           Should use G4EMLOW6.41

01.10.2014 L. Pandola et al, tag emlowen-V10-00-18
	   Fix of bugzilla 1612

02.09.2014 L. Pandola, tag emlowen-V10-00-17
	   Coverity fix. Restored deletion of G4Physics*Vector 
            objects at the destructor (as for ref-07)

28.08.2014 S. Incerti, tag emlowen-V10-00-16
           Coverity fix. 

07.08.2014 S. Incerti, tag emlowen-V10-00-15
           Removed unused code for atomic deexcitation.  

30.07.2014 V. Ivanchenko, tag emlowen-V10-00-14
           G4LivermorePhotoElectricModel, G4LivermoreGammaConversionModel,
           G4LivermoreRayleighModel, G4LivermoreComptonModel,
           G4IonParameterisedLossModel - added proper deletion
             of G4PhysicsVectors end of run

15.07.2014 V. Ivanchenko/L. Pandola, tag emlowen-V10-00-13
           LivermorePhotoElectricModel - keep cross section const 
           below lowest shell energy (as in Penelope model)
	   Changed Livermore, LivemorePolarized, LivemoreModified and 
           Penelope Compton to unify the treatment for 
           energy < LowEnergyLimit(). Null cross 
           section and no change in the gamma state. 

03.06.2014 V. Ivanchenko tag emlowen-V10-00-12
           G4LowEWentzelVIModel - cosmetic change trying to avoid 
             compillation problem for strict compiler 

19.05.2014 V. Ivanchenko/L. Pandola, tag emlowen-V10-00-11 
	   Bug fix in G4PenelopePhotoElectric effect (no fluorescence in 
           MT mode). Some cosmetics to G4PenelopeRayleigh.
           G4LowEWentzelVIModel - set single scattering factor 0.5

11.05.2014  V. Ivanchenko, tag emlowen-V10-00-10
            G4LowEWentzelVIModel - set single scattering factor 0.7 
              (was 1.0 before) - increasing accuracy but more slow
            G4AtomicTransitionManager, G4UAtomicDeexcitation,
            G4FluoData, G4LivermoreIonisationModel,
            G4PenelopeOscillatorManager - G4AtomicTransitionManager
              become pure singleton shared between threads, all
              run time methods are const;
              Initilise() method should be called in the beginning 
              of the run.

25.04.2014  S. Incerti, tag emlowen-V10-00-09
            Updated G4UAtomicDeexcitation according to previous tag 

21.04.2014  S. Incerti, tag emlowen-V10-00-08
            Fix of G4empCrossSection 

19.04.2014  S. Incerti, tag emlowen-V10-00-07
            Update of G4empCrossSection for Miranda et al. model 

15.04.2014  S. Incerti, tag emlowen-V10-00-06
            New class for ionisation cs model from Miranda et al. 

07.04.2014  V. Ivanchenko, tag emlowen-V10-00-05
            G4LowEWentzelVIModel - fixed initialisation

27.02.2014  V. Ivanchenko, tag emlowen-V10-00-04
            G4LivermorePhotoElectricModel - added low-energy cross 
            section for water
            G4IonParametrisedLossModel, G4LivermoreIonisationModel -
            added G4DeltaAngle generator for angular distribution

13.02.2014  V. Ivanchenko, tag emlowen-V10-00-03
            G4LowEWentzelVIModel - new class

24.01.2014  V. Ivanchenko, tag emlowen-V10-00-02
            G4LivermorePhotoElectricModel - fixed Coverity report 

10.01.2014  L. Pandola, tag emlowen-V10-00-01
	    Suppress G4Exception (JustWarning) issued by some Penelope 
            models in UnitTests. Controlled by verbosity flag now (for 
            diagnostic).

11.12.2013  L. Pandola, tag emlowen-V10-00-00
            Allow for (AutoLock-protected) creation on-the-fly of 
            tables in SampleSecondaries(). Nothing changes for loops driven 
            by the RunManager. Avoid crash when the loop of SampleSecondaries()
            is inkoved in a unit test.

22.11.2013  M. Karamitros, tag emlowen-V09-06-49
	    Remove creation of material in G4MuElect* 
	    and G4MicroElec* models

21.11.2013  V. Ivanchenko, tag emlowen-V09-06-48
            G4QAOLowEnergyLoss, G4hICRU49He, G4hICRU49p, 
	    G4hParametrisedLossModel  - removed G4ThreadLocal

20.11.2013  L. Pandola, tag emlowen-V09-06-47
	    Fix double-deletion problem reported by Gabriele 
	    and some cosmetics (G4PenelopeBremsstrahlungFS)

19.11.2013  V. Ivanchenko, tag emlowen-V09-06-46
            G4LivermoreComptonModel - fixed form-factor parameterisation
              by increasing number of digits in form-factor table

17.11.2013  V. Ivanchenko, L. Pandola, tag emlowen-V09-06-45
            G4LivermorePhotoElectricModel and G4PenelopeIonisationXSHandler,
             - fixed Coverity defect.
   
08.11.2013  V. Ivanchenko, tag emlowen-V09-06-44
            G4IonParametrisedLossModel - fixed destructor

08.11.2013  V. Ivanchenko, tag emlowen-V09-06-43
            G4IonDEDXHandler, G4LivermoreComptonModel,
            G4LivermoreGammaConversionModel, 
            G4LivermorePhotoElectricModel, G4LivermoreRayleighModel,
            G4LivermoreBremsstrahlungModel - cleanup

07.11.2013  V. Ivanchenko, tag emlowen-V09-06-42
            G4PenelopeBremsstrahlungAngular, 
            G4PenelopeBremsstrahlungFS, G4PenelopeBremsstrahlungModel,
            G4PenelopeIonisationXSHandler - do not delete
            G4PhysicsVector at destruction

07.11.2013  V. Ivanchenko, tag emlowen-V09-06-41
            G4IonDEDXHandler, G4LivermoreComptonModel,
            G4LivermoreGammaConversionModel, 
            G4LivermorePhotoElectricModel, G4LivermoreRayleighModel,
            G4PenelopeCrossSection, G4PenelopeGammaConversionModel,
            G4PenelopePhotoElectricModel, G4PenelopeRayleighModel
              - do not delete G4PhysicsVector at destruction 

05.11.2013  V. Ivanchenko, tag emlowen-V09-06-40
            G4LivermoreComptonModel - fixed compillation problem
            and problem of spectra due to which previous tag was
            rejected

02.11.2013  L. Pandola, tag emlowen-V09-06-39
	    Bug fixes in Penelope Ionisation and Bremsstrahlung
            after emlowen-V09-06-36. Should occur only in unit 
            tests or by G4EmCalculator.

01.11.2013  V. Ivanchenko, tag emlowen-V09-06-38
            G4LivermorePhotoElectricModel - do not upload data in 
            SampleSecondaries method, instead kill the gamma

01.11.2013  V. Ivanchenko, tag emlowen-V09-06-37
            G4LivermoreGammaConversionModel, G4LivermoreRayleighModel,
            G4LivermorePhotoElectricModel, G4LivermoreComptonModel - more
            accurate read data from file in run time (shoudl be used
            onlz in Unit tests and by G4EmCalculator)  

31.10.2013  L. Pandola, tag emlowen-V09-06-36
	    Allow for (AutoLock-protected) creation on-the-fly of 
            tables. Nothing changes for loops driven by the RunManager.
            Allows to get the CrossSection and StoppingPower without 
	    crash from Unit Tests and G4EmCalculator
	    
30.10.2013  L. Pandola, tag emlowen-V09-06-35
	    Implemented G4Cache in G4PenelopeBremsstrahlungFS, to 
	    avoid the new/delete mechanism of emlowen-V09-06-34 in 
	    a MT-safe way.

28.10.2013  L. Pandola, tag emlowen-V09-06-34             
	    Remove AutoLock from G4PenelopeBremsstrahlungFS. Support 
	    vector is allocated and released at every loop (not 
	    optimal) to avoid interference of threads.

27.10.2013  S. Incerti, M. Raine, tag emlowen-V09-06-33
            Updated sources.cmake
	    Fixed Coverity reports is G4LivermoreComptonMode (VI), 
            G4LivermorePhotoElectricModel (VI) and 
 	    G4PenelopeComptonModel (LP)

24.10.2013  S. Incerti, M. Raine, tag emlowen-V09-06-32
            Added G4MicroElec* processes and models 
	    in replacement of G4MuElec*

22.10.2013, V.Ivanchenko, tag emlowen-V09-06-31
            G4LivermoreComptonModel, G4LivermoreGammaConversionModel,
            G4RayleighAngularGenerator - use G4Log, G4Exp

22.10.2013, V.Ivanchenko, tag emlowen-V09-06-30
            G4LivermoreGammaConversionModelRC - fixed compillation 
            warnings due non-accurate definition of variables
            G4LivermoreComptonModel (A.Bagulya) and 
            G4LivermoreBremsstrahlungModel are migrated to MT 

17.10.2013, L.Pandola, tag emlowen-V09-06-29
	    Partially revert the MT migration of emlowen-V09-06-26 
            to fix a problem found by STT. The angular generator of 
	    Penelope bremsstrahlung is kept thread-local (one copy 
            per worker). 

16.10.2013, L.Pandola, tag emlowen-V09-06-28
	    Migration to MT for the Penelope Compton model
	    Fix Exception on G4PenelopeOscillatorManager 
            reported by Krzysztof Genser for specific materials

08.10.2013, L.Pandola, tag emlowen-V09-06-27	
	    Enforce const for G4PenelopeBremsstrahlungFS methods
            used by the workers.
	    Migration to MT for the Penelope Ionisation model,
	    and related helper classes (including Penelope PIXE).

07.10.2013, L.Pandola, tag emlowen-V09-06-26
	    Migration to MT for the Penelope models of 
	    bremsstrahlung and e+ annihilation.
            Improve CPU performances of G4PenelopePhotoElectricModel

01.10.2013, L.Pandola, tag emlowen-V09-06-25
	    Migration to MT for G4PenelopePhotoElectricModel,
            G4PenelopeRayleighModel and G4PenelopeGammaConversionModel

05.09.2013  M.Asai, tag emlowen-V09-06-24
            - G4IonDEDXScalingICRU73 - remove GetIon for reference
              Fe and Ar but use G4IonTable::GetIonMass() instead
              to prevent unnecessary instantiation of ion objects
              for individual threads.

09.08.2013  V.Ivanchenko, tag emlowen-V09-06-23
            - fixed bug in previous tag

09.08.2013  V.Ivanchenko, tag emlowen-V09-06-22
            - G4LivermorePhotoElectricModel - migration to MT

04.08.2013  S.Incerti, tag emlowen-V09-06-21
            - G4LivermoreGammaConversionModel - migration to MT

01.08.2013  V.Ivanchenko, tag emlowen-V09-06-20
            - G4PenelopeRayleighModel - removed debug printout
            - G4LivermoreRayleighModel - migration to MT: sharing
                internal tables between threads, two new methods
                added InitialiseLocal, InitialiseForElement

23.07.2013  V.Ivanchenko, tag emlowen-V09-06-18
22.07.2013  V.Ivanchenko, tag emlowen-V09-06-17
            - added protection for MT mode in G4PenelopeRaylModel

03.07.2013  M.Asai, tag emlowen-V09-06-16
            - Fix G4IonDEDXScalingICRU73.cc for multi-threading:
              "referenceAr" and "referenceFe" are now instantiated
              but not registered to the particel table.

25.06.2013  S.Incerti, B. Bouguelmouna, tag emlowen-V09-06-15
            - Fix Mi shell cross section computation in G4teoCrossSection

17.06.2013  V.Ivanchenko, tag emlowen-V09-06-14
            - G4IonDEDXHandler, G4IonParametrisedLossModel,
              G4LivermoreGammaConversionModel,
              G4PenelopeBremsstrahlungAngular - moved call
              SetSpline(true) to be always after the vector is 
              filled - only in that case spline interpolation
              is enabled in the most recent version of G4PhysicsVector

13.06.2013  M.Karamitros, tag emlowen-V09-06-13
	    - GNUmakefile: Dependency on hadronic package withdrawn

13.06.2013  M.Karamitros, tag emlowen-V09-06-12
	    - G4LowEPComptonModel.cc : Dependency on G4HadTmpUtil withdrawn
	    
29.03.2013  L.Pandola, tag emlowen-V09-06-11
	    - replaced "static G4ThreadLocal" with "static const" 
	      when applicable
            - added static keyword to some constants.

21.02.2013  V.Ivanchenko, L. Pandola, tag emlowen-V09-06-10 
            G4Generator2BN and G4PenelopeComptonModel 
	    - removed G4ThreadLocal declarations

15.02.2013  V.Ivanchenko, tag emlowen-V09-06-09
- G4LowEPComptonModel - fixed compillation problem at MAC and Windows

14.02.2013  V.Ivanchenko, tag emlowen-V09-06-08
- G4LowEPComptonModel - J.Brown fixed numerical problem (seen by FPE)

06.02.2013  S. Incerti, tag emlowen-V09-06-07
- Removed useless verbosity

20.12.2012  V.Ivanchenko, tag emlowen-V09-06-06
- Fixed build

20.12.2012  V.Ivanchenko, tag emlowen-V09-06-05
- G4AtomicDeexcitation is return back as number of classes
    which are still in use
- G4PenelopeIonisationModel - removed unused obsolete header

19.12.2012  V.Ivanchenko, tag emlowen-V09-06-04
- Fixed build problems

19.12.2012  V.Ivanchenko, tag emlowen-V09-06-03
- G4AtomicDeexcitation is cloned from G4UAtomicDeexcitation
- removed obsolete unused classes

07.12.2012  V.Ivanchenko, tag emlowen-V09-06-02
- G4MuElecInelastic, G4MuElecElastic - substituted calls to obsolete 
    method

05.12.2012  L. Pandola, tag emlowen-V09-06-01
	    Slightly change the fix on G4LivermorePhotoElectricModel 
  	    introduced in the previous tag; bug fix #1402

04.12.2012  A. Mantero, tag emlowen-V09-06-00
- G4LivermorePhotoElectricModel: fixed a bug in line 310
- G4UAtomDeexcitation: Added some debug options

12.11.2012  V.Ivanchenko, tag emlowen-V09-05-48
- G4MuElecInelasticModel Gunter Folger fixed usage of iterators at 
    boundary of vectors

06.11.2012  G.Cosmo, tag emlowen-V09-05-47
- Minor fixes for porting on AIX; mainly on use of const signature for
  objects in maps...

02.11.2012  V.Ivanchenko, tag emlowen-V09-05-46
- G4LivermorePhotoElectricModel - fixed non-initialised variable in prvious tag

02.11.2012  V.Ivanchenko, tag emlowen-V09-05-45
- G4LivermorePhotoElectricModel - migration to G4PhysicsVector data structure

20.10.2012  V.Ivanchenko, tag emlowen-V09-05-44
- G4RayleighScattering - substitute methods Model(), SetModel()
    by EmModel(), SetEmModel()
- G4LivermoreGammaConversionModel - removed variable shadowing

17.10.2012  M. Raine, tag emlowen-V09-05-43
	    Update of MuElec classes to widen the energy range of application.

28.09.2012  G.Cosmo, tag emlowen-V09-05-42
            Explicitly use inclusion of headers for system of units and
            physical constants, in plan to remove implicit inclusion from
            globals.hh.

26.09.2012  S.Incerti, tag emlowen-V09-05-41
            Added renamed Compton low energy model by JB et al.

21.09.2012  V.Ivanchenko, tag emlowen-V09-05-40
            G4PhotoElectricAngularGeneratorPolarized, G4Generator2BN,
            G4Generator2BS, G4RayleighAngularGenerator - added 
              protection against cos(theta) < -1 to avoid numerical
              problems
            G4LivermoreRayleighModel - fix exception printout
            G4Livermore2012GammaConversionModel - temporary class removed

17.09.2012  S. Incerti, tag emlowen-V09-05-39 to 37
            Updated sources.cmake       

17.09.2012  S. Incerti, tag emlowen-V09-05-36
            Renamed Monash U. Compton model       

01.08.2012  V.Ivanchenko, tag emlowen-V09-05-35
            G4LivermorePolarizedPhotoElectricModel - removed debug cout 

31.07.2012  V.Ivanchenko, tag emlowen-V09-05-34
            G4LivermorePolarizedPhotoElectricModel - fixed initialisation 

28.07.2012  V.Ivanchenko, tag emlowen-V09-05-33
            G4LivermorePolarizedPhotoElectricModel - use 
              G4SauterGavrilaAngularDistribution as it was in 9.5 
              instead of G4PhotoElectricAngularGeneratorPolarized
              to avoid infinite loop in angular sampling

26.07.2012  V.Ivanchenko, tag emlowen-V09-05-32
            G4PhotoElectricAngularGeneratorPolarized - added protection 
              against infinite loop

26.07.2012  V.Ivanchenko, tag emlowen-V09-05-31
            G4Generator2BN - use G4Generator2BS for Ekin > 1.5 MeV
            G4LivermorePhotoElectricModel, 
            G4LivermorePolarizedPhotoElectricModel - use angular
              generator via G4VAngularDistribution interface
              removed headers and initialisation of old 
              deexcitation
            G4PhotoElectricAngularGeneratorSimple,
            G4PhotoElectricAngularGeneratorSauterGavrila,
            G4PhotoElectricAngularGeneratorPolarized - migrated
              to G4VAngularDistribution interface

20.07.2012  V.Ivanchenko, tag emlowen-V09-05-30
            G4Generator2BS - fixed sampling according to original paper
            G4Generator2BN - cleanup

20.07.2012  V.Ivanchenko, L.Pandola tag emlowen-V09-05-29
            G4LivermoreBremsstrahlungModel, G4LivermoreRayleighModel,
            G4RayleighAngularGenerator, G4Generator2BN, G4Generator2BS,
            G4PenelopeBremsstrahlungAngular, G4PenelopeBremsstrahlungModel
            migrated to the common SampleDirection interface of the pure
            virtual G4VEmAngularDistribution interface 

17.07.2012  V.Ivanchenko, tag emlowen-V09-05-28
            G4RayleighScattering - use high energy table above 100 keV
            G4LivermoreRayleighModel - updated by S.Incerti
            G4RayleighAngularGenerator - new class (A.Ivantchenko)
            G4LivermoreGammaConversionModel - is a new version (S.Incerti)
            G4Livermore2012GammaConversionModel - temporary keep old version

11.07.2012  G.Cosmo, tag emlowen-V09-05-27
            Explicitly use inclusion of headers for system of units and
            physical constants, in plan to remove implicit inclusion from
            globals.hh.

29.06.2012  L.Pandola, tag emlowen-V09-05-26
	    Corrected G4PenelopeBremsstrahlungFS to avoid the anomaly 
	    in the gamma-ray spectrum close to the cut which was 
	    reported by Vladimir

21.06.2012  JB, tag emlowen-V09-05-25 (committed by SI)
            Fix in G4MUComptonModel 

20.06.2012  JB, tag emlowen-V09-05-24 (committed by SI)
            Update of G4MUComptonModel & G4LivermoreComptonModel classes

13.06.2012  S. Incerti, tag emlowen-V09-05-23
            Shadowing issues fixes

01.06.2012  S. Incerti, tag emlowen-V09-05-22
            Coverity fix of G4MUComptonModel.cc

21.05.2012  S. Incerti, J. Brown, tag emlowen-V09-05-21
            Update of G4MUComptonModel.cc

03.05.2012  S. Incerti, J. Brown, tag emlowen-V09-05-20
            Corrected compil. warning in G4MUComptonModel.cc

29.04.2012  S. Incerti tag emlowen-V09-05-19
            Coverity fixes

19.04.2012  S. Incerti tag emlowen-V09-05-18
            New draft class G4Livermore2012GammaConversionModel

16.04.2012  L. Pandola tag emlowen-V09-05-17
            Copy of the previous tag (rejected for other reasons)
	    Database G4LEDATA updated to G4EMLOW6.26 in the meanwhile 
            (no real effect, removed unused files only).

10.04.2012  L. Pandola tag emlowen-V09-05-16
	    Removed obsolete Penelope v2001 models and releted 
	    helper classes. A clean-up of G4LEDATA will follow 
	    (there are unused files now) 

04.04.2012  M. Raine, S. Incerti tag emlowen-V09-05-15
            - Delivered processes and models for microdosimetry in Si
	    for electrons, protons and ions. These processes and models
	    are described in the following publications:
	    - Inelastic cross-sections of low energy electrons in silicon
	    for the simulation of heavy ion tracks with theGeant4-DNA toolkit,
	    NSS Conf. Record 2010, p80-85
	    - Geant4 physics processes for microdosimetry simulation:
	    very low energy electromagnetic models for electrons in Si,
	    to be published in TNS
	    - Geant4 physics processes for microdosimetry simulation:
	    very low energy electromagnetic models for protons and
	    heavy ions in Si, to be published in NIMB	
	    by A. Valentin, M. Raine, J.E. Sauvestre, 
	    M. Gaillardin, P. Paillet
	    - to be used with G4LEDATA version 6.25    

03.04.2012  S. Incerti, L. Pandola tag emlowen-V09-05-14
	    - Updated GNUMakefile for usage of G4lrint 
	    - Fixes of coverity defects in Penelope classes (bug fixes)

02.04.2012  S. Incerti tag emlowen-V09-05-13
	    Update to G4lrint by J. Brown (G4MUComptonModel)

30.03.2012  S. Incerti tag emlowen-V09-05-12
	    Added new rounding method developped by J. Brown for Windows 
	    compilation of new Compton model (G4MUComptonModel)

26.03.2012  S. Incerti tag emlowen-V09-05-11
	    Added new Compton model (G4MUComptonModel) developped by
	    J. M. C. Brown, M. R. Dimmock, J. E. Gillam and D. M. Paganin,
	    Monash University, Australia
	    
22.03.2012  L. Pandola tag emlowen-V09-05-10
	    Penelope-based XS model for electron PIXE 
	    registered in G4UAtomicDeexcitation.
	    Added warning messages to Penelope models to 
	    verify the proper activation of fluorescence.

20.03.2012  L. Pandola tag emlowen-V09-05-09
	    Updated G4PenelopeOscillatorManager to accomodate the 
	    calculation of PIXE cross sections. First implementation 
	    of Penelope-specific PIXE cross sections: 
	    G4PenelopeIonisationCrossSection (derived from 
	    G4VhShellCrossSection). **Preliminary**

14.03.2012  L. Pandola tag emlowen-V09-05-08
	    1) Make G4PenelopeBremsstrahlungAngular derived by the basic 
	    interface G4VEmAngularDistribution. Makes angular generator 
	    usable by any other model via the interface.
	    2) Rename G4PenelopeIonisationCrossSection to
	    G4PenelopeIonisationXSHandler (the name will be reserved for 
	    a different class in a while)
	    3) Make G4PenelopeCrossSection able to return both absolute 
	    and normalized values of the shell cross sections. It will be 
	    used for Penelope-PIXE.

09.03.2012  L. Pandola tag emlowen-V09-05-07
	    Minor design iteration for G4VhShellCrossSection base class, 
            in order to carry also the information about G4Material. Also 
            preliminar step for a future Penelope-specific fluorescence 
            model.

09.03.2012  L. Pandola tag emlowen-V09-05-06
	    Decouple calculation of Penelope ionisation cross sections
	    from the Ionisation model. Preliminary step for a future 
            Penelope-specific AtomicDeexcitation model.

06.03.2012  V.Ivanchenko tag emlowen-V09-05-05
            G4IonParametrisedLossModel - fixed minor memory leak

20.02.2012  L. Pandola tag emlowen-V09-05-04
	    Make a consistent use of G4Element::GetA() and 
            G4Element::GetAtomicMassAmu() in the Penelope models

09.02.2012  L. Pandola  tag emlowen-V09-05-03
	    Get rid of the compiler warning (gcc-4.6) which caused 
            the rejection of tag emlowen-V09-05-02

27.01.2012  L. Pandola  tag emlowen-V09-05-02
	    Remove in G4PenelopeIonisationModel the dependency on the 
	    obsolete G4AtomicDeexcitation (gets rid of warning on screen)

24.01.2012  L. Pandola  tag emlowen-V09-05-01
	    Fix all remaining defects reported by the Coverity 
	    analysis

11.01.2012  L. Pandola, tag emlowen-V09-05-00
	    Fix defects reported by the Coverity analysis for all 
	    Penelope-related classes

25.11.2011  V.Ivanchenko tag emlowen-V09-04-81
            Minor cleanup of comments

14.11.2011  L. Pandola tag emlowen-V09-04-80
            Added further protection in G4PenelopeBremsstrahlungFS.cc to 
	    avoid exception em2015. The problem looks to be 
            system-dependent

13.11.2011  S. Incerti tag emlowen-V09-04-79
	    Adapted form factor ionization cross sections for the new 
	    set of ionization data proposed by M. Reis & A. Taborda.

11.11.2011  L.Pandola tag emlowen-V09-04-78
	    Remove a left-over old-style G4Exception(), which 
	    did not compile any longer.

10.11.2011  A.Mantero tag emlowen-V09-04-77
            BugFix: G4OrlicLiXsModel lower edge for L1 adjusted

09.11.2011  A.Mantero tag emlowen-V09-04-76
            BugFix: G4EmpCrossSection returns zero for alpha particles on L-shells

07.11.2011  A.Mantero tag emlowen-V09-04-75
            Minor bug fixing in G4UAtomDeexcitation +
            coverity waring fixes for Deexcitation Classes

05.11.2011  A.Mantero tag emlowen-V09-04-74
            re-tag of the previous gone bad due to svn random behavior

05.11.2011  A.Mantero tag emlowen-V09-04-73
            Some minimal bug fixes on Deexcitation classes

03.11.2011  G.Cosmo tag emlowen-V09-04-72
            Again fix to source.cmake for case sensitive specifications of
            file G4OrlicLiXsModel[.hh.cc]...

03.11.2011  G.Cosmo tag emlowen-V09-04-71
            Again fix to source.cmake for classes deleted...

02.11.2011  V.Ivanchenko tag emlowen-V09-04-70
            Fixed source.cmake

02.11.2011  L.Pandola tag emlowen-V09-04-69
	    Add additional verbosity in G4PenelopeBremsstrahlungFS 
            in the attempt to sort of the reason of G4Exception 
	    em2015 observed in STT.

28.10.2011  A.Mantero, V.Ivantchenko tag emlowen-V09-04-68
	    added initialization of data members in constructor
	    of G4UAtomDeexcitation to avoid Coverity warnings

28.10.2011  A.Mantero, tag emlowen-V09-04-67
	    Changed names for Ecpssr calculations from Form Factor
	    according to A.Taborda et al. X-Ray Spectrom. 
	    2011, 40, 127-134. Update of G4UAtomDeexcitationto remove
            runtime warning if Deexciation is not used

28.10.2011  L.Pandola, tag emlowen-V09-04-66
	    Include files G4ECPSSRFormFactorKCrossSection.* and 
	    G4ECPSSRFormFactorLiCrossSection.* from A. Mantero.
	    Edit the sources.cmake accordingly

26.10.2011  L.Pandola, tag emlowen-V09-04-65
            Added protection in G4PenelopeBremsstrahlungFS.cc in the 
	    attempt to avoid exception em2015 which caused the rejection 
            of emlowen-V09-04-61. The problem might be system-dependent

22.10.2011  A.Mantero, tag emlowen-V09-04-64
            Fixed warning and X control in G4PaulKCrossSection
            Fixed a bug on return unit of G4ECPSSRFormFactorLiCrossSection.cc, 
            G4ECPSSRFormFactorKCrossSection.cc

20.10.2011  A.Mantero, tag emlowen-V09-04-63
	    Added G4ECPSSRFormFactor*CrossSection classes and
            modified the other accordingly.

19.10.2011  L.Pandola, tag emlowen-V09-04-62
	    Bug fix in G4PenelopeOscillatorManager, which caused 
	    a G4Exception for some materials (found by 
	    L. Urban)

07.10.2011  L.Pandola, tag emlowen-V09-04-61
	    Bug fix in G4PenelopePhotoElectricModel, which 
	    caused a potential violation of energy conservation 
            in high-Z materials (found by L. Urban)

27.09.2011  S.I., F.L., G.D., tag emlowen-V09-04-60
            Added similar protection for cosTheta above 5 MeV 
            in G4LivermorePolarizedRayleighModel as in unpolarized model

05.09.2011  L.Pandola, tag emlowen-V09-04-59
	    Edited G4PenelopeOscillatorManager in order to 
	    use the shell binding energy from the G4AtomicDeexcitation
	    data, rather than from the local Penelope database. This 
	    fixes small inconsistencies.

01.09.2011  S.I., L.P., A.M., tag emlowen-V09-04-58
            Removed obsolete G4Exception syntax

23.08.2011  S.Incerti, tag emlowen-V09-04-57
            Removed obsolete codes in test

08.08.2011  S.Incerti, tag emlowen-V09-04-56
            Removed all obsolete G4eLowEnergyLoss* classes

03.08.2011  S.Incerti, tag emlowen-V09-04-55
            Removed all obsolete G4LowEnergy* classes

28.07.2011  S.I. + L.P. + V.I. tag emlowen-V09-04-54
	    -Use SetDeexcitationFlag(true) in the migrated 
	    Livermore models.
	    -Removed printouts in Penelope migrated models.

26.07.2011  L. Pandola tag emlowen-V09-04-53
	    Use SetDeexcitationFlag(true) in the migrated 
	    Penelope models (flag that atomDeex is applicable 
	    for these models).

21.07.2011  A. Mantero tag emlowen-V09-04-52
	    Fixed coverity warnings.

05.07.2011  L. Pandola tag emlowen-V09-04-51
            Fixed coverity warnings.

02.07.2011  S. Incerti, tag emlowen-V09-04-50
	    Fixed coverity warnings.

21.06.2011  L. Pandola, tag emlowen-V09-04-49
	    Fixed bug in G4PenelopeOscillatorManager reported by 
	    Gunter F. while testing under Windows

16.06.2011  V. Ivanchenko, tag emlowen-V09-04-48
            G4LivermorePolarizedGammaConversionModel - fixed problem 
            introduced in the previous tag

15.06.2011  V. Ivanchenko, tag emlowen-V09-04-47
            G4BremsstrahlungParameters - fixed value of the density effect
            constant (Migdal constant) using standard relativistic model
            G4LivermorePolarizedGammaConversionModel - added protection 
            in numeric computations to avoid FPE crash, minor cleanup
            of the initialisation

14.06.2011  S. Incerti, tag emlowen-V09-04-46
	    Corrected Windows compilation pblm (asinh) for Boldyshev triplet 
	    model.

11.06.2011  S. Incerti, tag emlowen-V09-04-45
	    Commited Boldyshev triplet model on behalf of Francesco & Gerardo

10.06.2011  L. Pandola, tag emlowen-V09-04-44
	    Migrated PhotoElectric and Compton Penelope models (v2008)
	    to the new interface for atomic de-excitation. For the time being, 
	    Ionisation model is left out, as well as the v2001 models

09.06.2011  L. Pandola, tag emlowen-V09-04-43
	    Fixed coverity defects in G4Penelope files

06.06.2011  S. Incerti, tag emlowen-V09-04-42
            Fixed coverity warnings.

01.06.2011  V. Ivanchenko, tag emlowen-V09-04-41
            Added G4LivermoreIonisationCrossSection and
            G4eCrossSectionHandler
            G4LivermoreIonisationModel, G4LivermorePhotoElectricModel
            are migraded to common design with standard for deexcitation
            G4LivermoreComptonModel - deexcitation is added
            G4UAtomicDeexcitation - added e+- cross section separately
            from hadron cross sections

30.05.2011  V. Ivanchenko, tag emlowen-V09-04-40
            Fixed run time crash in G4LivermorePhotoElectricModel

30.05.2011  L. Pandola, tag emlowen-V09-04-39
	    Bug fix in G4PenelopeComptonModel and 
	    G4PenelopeBremsstrahlungFS

26.05.2011  L. Pandola, tag emlowen-V09-04-38
	    Fixed include/src list in sources.cmake

26.05.2011  L. Pandola, tag emlowen-V09-04-37
	    Fixed floating-point exceptions reported by Vladimir I. 
	    in G4PenelopeRayleighModel

25.05.2011  L. Pandola, tag emlowen-V09-04-36
	    Removed G4Penelope08XXXXModel files that have been renamed as 
	    G4PenelopeXXXModel. Now v2008 of Penelope is used as 
	    default. 
	    Notice: may break compatibility with applications which 
	    include specifically G4Penelope08XXXModel.hh files

25.05.2011  L. Pandola, tag emlowen-V09-04-35
	    Copy all Penelope08Models (v2008) as default 
	    PenelopeXXXModel. Preparation to delete 
	    Penelope08Model files

24.05.2011  L. Pandola, tag emlowen-V09-04-34
	    Copy all PenelopeModels (v2001) as Penelope01xxxModel.
	    Preparation before moving Penelope08Models as 
	    default Penelope models

16.05.2011  S. Incerti, tag emlowen-V09-04-33
            Fix compilation warnings with gcc 4.6.0
	    G4AtomicDeexcitation.cc
	    G4Generator2BN.cc
	    G4IonDEDXHandler.cc
	    G4LivermorePolarizedGammaConversionModel.cc
	    G4OrlicLiCrossSection.cc
	    G4UAtomicDeexcitation.cc
	    G4VeLowEnergyLoss.cc

10.05.2011  L. Pandola, tag tag emlowen-V09-04-32
	    Fix Coverity warnings for G4Generator2BS, G4VCrossSectionHandler,
	    G4PhotoElectricAngularGeneratorPolarized, G4DopplerProfile, 
	    G4VeLowEnergyLoss and G4CrossSectionDataSet.

09.05.2011  A. Mantero, tag emlowen-V09-04-30/31
	    Fixed Coverity Warning for Atomic Deexcitation files
            and History update 

09.05.2011  L. Pandola, tag emlowen-V09-04-29
	    Fixed Coverity warnings for G4eIonisationCrossSectionHandler, 
	    G4eIonisationParameters, 
            G4PhotoElectricAngularGeneratorSauterGavrila, 
            G4BremsstrahlungParameters and G4Penelope08BremsstrahlungFS
	
02.05.2011  S. Incerti, tag emlowen-V09-04-28
            Fixed coverity warnings
	    G4LivermorePolarizedGammaconversionModel.cc
	    G4LowEnergyGammaConversion.cc
	    G4LivermorePolarizedPhotoElectricModel.hh

04.05.2011  L. Pandola, tag emlowen-V09-04-27
	    Removed CLHEP::HepMatrix dependency in the Penelope08 files.

02.05.2011  S. Incerti, tag emlowen-V09-04-26 
            Replaced CLHEP::RandBit by G4int(2*G4UniformRand()) in Livermore
	    gamma conversion classes, thanks to Gabriele.
	    Changes applied to the following *.cc classes:
	    G4LivermoreGammaConversionModel
	    G4LivermoreGammaConversionModelRC
	    G4LivermoreNuclearGammaConversionModel
	    G4LivermorePolarizedGammaConversionModel
	    G4LowEnergyGammaConversion
	    
28.04.2011  S. Incerti, tag emlowen-V09-04-25
            Removal of parasitic verbosity.

27.04.2011  S. Incerti, tag emlowen-V09-04-24
            Removal of some obsolete classes
	    - old livermore photon polarized processes (G4LowEnergyPolarized*)
	    - old shell cross sections (G4hShell*)
	    - old ion ionisation process (G4ionLowEnergyIonisation)
	    - old h ionisation process (G4hLowEnergyIonisation)
	    - old G4hLowEnergyLoss

27.04.2011  G. Cosmo, tag emlowen-V09-04-23
            Fixed compilation warnings in G4hShellCrossSectionExp and
            G4hShellCrossSectionDoubleExp for unused parameters.

28.03.2011  V. Ivanchenko, tag emlowen-V09-04-22
            Removed parasitic printout

28.03.2011  V. Ivanchenko, tag emlowen-V09-04-21
            Fixed compillation

27.03.2011  A. Mantero, tag emlowen-V09-04-20
	    Warning update for PIXE and Deexcitation.

27.03.2011  A. Mantero, tag emlowen-V09-04-19
	    Some bug fixes for PIXE and Deexcitation.

25.03.2011  S. Incerti, tag emlowen-V09-04-18
            commented ionization classes for better clarity.

17.03.2011  S. Incerti, tag emlowen-V09-04-17
            Updated sources.cmake.

17.03.2011  S. Incerti, tag emlowen-V09-04-16
            Created new G4CrossSectionDataSet class.

17.03.2011  S. Incerti, tag emlowen-V09-04-15
            Removal of all Geant4-DNA classes.

28.02.2011  S. Incerti, tag emlowen-V09-04-14
            Corrected control of warnings in ion. cross section model classes.

14.02.2011  S. Incerti, tag emlowen-V09-04-13
            Corrected verbose in G4DNA Champion elastic model class.

14.02.2011  S. Incerti, tag emlowen-V09-04-12
            Removal of obsolete dummy class

14.02.2011  S. Incerti, tag emlowen-V09-04-11
            Removal of all obsolete Geant4-DNA classes

02.02.2011  L. Pandola, tag emlowen-V09-04-10
	    Updated Compton and Ionisation for Penelope and Penelope08 
	    (to fix the same issue as tag emlowen-V09-04-09). Fix 
	    Coverity defects in G4Penelope08 models

01.02.2011  L. Pandola, tag emlowen-V09-04-09
	    Changed G4Penelope08PhotoElectricModel and G4PenelopePhotoElectricModel to 
	    suppress fake energy-violation warning and to make sure that fluorescence/Auger 
            is generated only if above threshold

24.01.2011  L. Pandola, tag emlowen-V09-04-08
	    Removed all obsolete G4Penelope processes and the 
	    obsolete class G4PenelopeCrossSectionHandler.
	    * Files to be restored in case of patches to G4 9.4 * 

24.01.2011  S. Incerti, tag emlowen-V09-04-07
            Fixed coverity warnings for G4DNA classes.

18.01.2011  L.Pandola, tag emlowen-V09-04-06
	    Fix memory leak in G4CrossSectionHandler, reported by 
	    Coverity

18.01.2011  L.Pandola, tag emlowen-V09-04-05
	    Edited G4Penelope08IonisationModel and G4PenelopeIonisationModel 
	    to avoid the production of sub-threshold delta-rays.

04.01.2011  V.Ivanchenko, tag emlowen-V09-04-04
            G4UAtomicDeexcitation, G4empCrossSection, G4teoCrossSection,
            G4VhShellCrossSection - fixed inefficiency in computation 
            of ionisation cross sections, now both models work with
            similar speed; added extra protections limited usage of 
            a model in applicability range

27.12.2010  V.Ivanchenko, tag emlowen-V09-04-03
            Fixed memory leaks at initialisation of G4LivermoreComptonModel,
            G4LivermoreGammaConversionModel, G4LivermorePhotoElectricModel,
            G4LivermoreRayleighModel;
            Fixed Coverity warnings in G4EMDataSet and G4ShellData;
            Moved constructor and destructor to source in G4VEMDataSet

20.12.2010  L. Pandola, tag emlowen-V09-04-02
	    Add the new Bremsstrahlung model based on Penelope v2008
	    Requires version 6.20 of G4LEDATA

15.12.2010  L. Pandola, tag emlowen-V09-04-01
	    fixed Coverity defects for G4Penelope08 models 

09.12.2010  V.Ivanchenko, tag emlowen-V09-04-00
            fixed memory leak at initialisation of G4eIonisationParameters,
            G4ShellVacancy, G4LivermoreIonisationModel, 
            G4LivermoreBremsstrahlungModel, G4EMDataSet,
            G4BremsstrahlungParameters

02.12.2010  V.Ivanchenko, tag emlowen-V09-03-69
            fixed minor memory leaks in G4VCrossSectinDataSet, G4EMDataSet,
            G4LivermoreBremsstrahlungModel, G4LivermoreIonisationModel

01.12.2010, L.Pandola, tag emlowen-V09-03-68
	    Address Coverity reports for a few Penelope/Livermore
	    models.

26.11.2010, L.Pandola, tag emlowen-V09-03-67
            Address Coverity reports for a few Penelope/Livermore

25.11.2010  tag emlowen-V09-03-66
            V.Ivanchenko fixed initialisation in
            G4UAtomicDeexcitation: delete objects, use consistent names

25.11.2010, L.Pandola, tag emlowen-V09-03-65
	    Address Coverity reports for a few Penelope/Livermore 
	    classes

22.11.2010, A.Mantero, tag emlowen-V09-03-64
	    changed default for PIXE model

22.11.2010, A.Mantero, tag emlowen-V09-03-63
            minor fixes

22.11.2010, A.Mantero, tag emlowen-V09-03-62
	    units management in PIXE fixed
            calculation bug in G4UAtomicDeexcitation fixed

19.11.2010, A.Mantero, tag emlowen-V09-03-61
            bug removal from G4LivermoreIonisation
            bug removal from G4LivermorePolarizedPhotoElectricModel

12.11.2010, A.Mantero, tag emlowen-V09-03-60
	    minor fixes and added a test for G4UAtomicDeexcitation
	    in test subdir

12.11.2010, A.Mantero, tag emlowen-V09-03-59
	    Creation of G4UAtomicDeexcitation class,
	    derived from G4VAtomicDeexcitation in Utils.
	    It will replace G4AtomicDeexcitation class.
	    Updated G4hLowEnergyIonisation to use G4UAtomicDeexcitation 
	    instead of G4AtomicDeexcitation.


12.11.2010, V. Ivanchenko, tag emlowen-V09-03-58
            G4BoldyshevTripletModel - F.Longo substitute asinh,
            because it is absent at Windows

12.11.2010, S. Incerti, tag emlowen-V09-03-57
            Renamed inline function in Sanche excitation model

11.11.2010, S. Incerti, tag emlowen-V09-03-56
            Added new control of low energy limit of G4DNA e- models
            Energy ranges adapted accordingly.

10.11.2010, V. Ivanchenko, tag emlowen-V09-03-55
            F.Longo and G.Depaola provided new models:
            G4BoldyshevTripletModel, G4LivermoreGammaConversionModelRC,
            G4LivermoreNuclearGammaConversionModel; 
            G4LivermorePolarizedGammaConversionModel - fixed element
            selection and initialisation 

04.11.2010, S. Incerti, tag emlowen-V09-03-54
            - removed warnings in Rudd ionization classes (SI)
            - G4IonParametrisedLossModel - (VI) moved few virtual methods from
            inline to source, minor cleanup of initialisation  

03.11.2010, S. Incerti, tag emlowen-V09-03-53
            restricted momentum conservation to electrons 
            in G4DNA ionisation

03.11.2010, S. Incerti, tag emlowen-V09-03-52
            new preliminary Geant4-DNA ionisation class for ions by Z. Francis
            to be used with G4LEDATA 6.18

17.10.2010, S. Incerti, tag emlowen-V09-03-51
            extended low energy coverage of G4DNA electron models
            to be used with G4LEDATA 6.17

14.10.2010, V. Ivanchenko, tag emlowen-V09-03-50
            G4GeneratorBS - optimise computations to speedup, fixed comments
            G4GeneratorBN - fixed comments
            G4VBremAngularDistribution - moved to utils
            G4ModifiedTsai - moved to standard 

13.10.2010, L. Pandola, tag emlowen-V09-03-49
            Update G4LivermoreIonisationModel to produce fluorescence AlongStep 
            only if above the production cuts. Stricter check for energy 
            conservation

08.10.2010, S. Incerti, tag emlowen-V09-03-48
            Added new excitation model for H

15.09.2010, S. Incerti, tag emlowen-V09-03-47
            Added protection in xs file opening for G4DNA Sanche excitation

15.09.2010, S. Incerti, tag emlowen-V09-03-46
            Corrected data file names in G4DNA Melton and Sanche        

08.09.2010, S. Incerti, tag emlowen-V09-03-45
            Updated high energy limits of G4DNAExcitation and G4DNAIonisation

08.09.2010, S. Incerti, tag emlowen-V09-03-44
            Set high energy limit of G4DNAScreenedRutherfordModel to 1 MeV

08.09.2010, S. Incerti, tag emlowen-V09-03-43
            Added new G4DNA processes and models for vib. exc & attachment
            Provided by Z. Francis et al. - Appl. Rad. Isot. (2010)
            http://dx.doi.org/10.1016/j.apradiso.2010.08.011
            to be used with G4LEDATA 6.16

08.09.2010, S. Incerti, tag emlowen-V09-03-42
            Decreased low energy limit of G4DNAScreenedRutherfordModel

05.09.2010, S. Incerti, tag emlowen-V09-03-41
            Bugzilla 1120
            Modified G4PhotoElectricAngularGeneratorSauterGavrila.cc
            as proposed by J. Goldberg

25.08.2010, S. Incerti, tag emlowen-V09-03-40
            - updated & extended Rudd and Miller & Green models
            - to be used with G4LEDATA 6.15

25.08.2010, S. Incerti, tag emlowen-V09-03-39
            -Adapted all high energy limits of G4DNA electron models

24.08.2010, S. Incerti, tag emlowen-V09-03-38
            -Changed low energy limit of G4DNA elastic scattering models for e-
            -Switched default excitation model for e- to Born
            -to be used with G4LEDATA 6.14

28.07.2010, L. Pandola, tag emlowen-V09-03-37
            First full version of G4Penelope08IonisationModel, model for e+/e- 
            ionisation according to Penelope v2008. Still beta version. 

26.07.2010, L. Pandola, tag emlowen-V09-03-36
            Added class G4PenelopeCrossSection to store/handle cross sections 
	    (and higher momenta, like stopping powers) for the updated 
            Penelope08 e+/e- models (ionisation and bremsstrahlung).

15.06.2010, G. Cosmo, tag emlowen-V09-03-35
            Corrected return value case in method GetPhotoElectronDirection()
            in G4PhotoElectricAngularGeneratorSauterGavrila; addressing problem
            report #1120.
            Added missing virtual destructor to G4VecpssrKModel and
            G4VecpssrLiModel base classes.

14.06.2010, A. Lechner, tag emlowen-V09-03-34
            Made desctructor of base class G4VIonDEDXScalingAlgorithm virtual
            (avoids also compiler warnings).

10.06.2010, A. Mantero, tag emlowen-V09-03-33
            Fix in G4AugerTransition to cure crash on Windows.

09.06.2010, A. Mantero, tag emlowen-V09-03-32
            Fixed compilation warning in G4AnalyticalEcpssrKCrossSection.

08.06.2010, S. Incerti, tag emlowen-V09-03-31
            modified initialisation of e- Emfietzoglou excitation
            model in G4DNAEmfietzoglouExcitationModel.cc and
            in G4DNAMillerGreenExcitationModel.cc

07.06.2010, A. Mantero, tag emlowen-V09-03-30
	    added analytical (ecpssr) and empirical (Paul and Orlic)
	    models for the calculation of hadronc shell ionisation CS 

29.04.2010, L. Pandola, tag emlowen-V09-03-29
	    Removed the compiler warning in G4PenelopeIonisationModel.cc which 
            caused the rejection of emlowen-V09-03-28

23.04.2010, L. Pandola, tag emlowen-V09-03-28
	    Removed useless call in G4PenelopeIonisationModel which triggered fake 
            warning messages

15.04.2010, L. Pandola, tag emlowen-V09-03-27
	    Added MinEnergyCut() method to G4PenelopeIonisationModel. Small (minor) 
	    changes to other G4Penelope models (mainly clean-up)

08.04.2010, S. Incerti, tag emlowen-V09-03-26
            Changed computation of scattering angle in G4DNAChampionElasticModel.cc
            G4EMLOW 6.12 version needed
  
07.04.2010, S. Incerti, tag emlowen-V09-03-25
            Fixed memory leak in G4DNARuddIonisationModel.cc

06.04.2010, S. Incerti, tag emlowen-V09-03-24
            Replaced hard coded masses in G4DNADingfelderCharge*.cc

31.03.2010, L. Pandola, tag emlowen-V09-03-23
	    Removed G4cout's used for debugging in G4Penelope08ComptonModel and 
	    G4Penelope08PhotoElectricModel

27.03.2010, S. Incerti, tag emlowen-V09-03-22
            Modified G4DNABornIonisationModel.hh

27.03.2010, S. Incerti, tag emlowen-V09-03-21
            Modified method declaration in G4DNABornExcitation.hh

27.03.2010, S. Incerti, tag emlowen-V09-03-20
            Added new excitation model for electrons in G4DNABornExcitationModel

26.03.2010, S. Incerti, tag emlowen-V09-03-19
            Modified electron correction in G4DNAMillerGreenExcitation.cc

26.03.2010, S. Incerti, tag emlowen-V09-03-18
            Extended range of search for maximum of DCS in G4DNARuddIonisationModel.cc            

26.03.2010, S. Incerti, tag emlowen-V09-03-17
            Changed default parameters of G4DNAEmfietzoglouExcitationModel.hh

26.03.2010, tag emlowen-V09-03-16
            - S. Incerti : corrected G4DNABornIonisationModel.cc class 
                           for maximum kinetic energy transfer
            - A. Mantero: fixed bugs in G4AtomicDeexcitation.cc, G4AugerTransition.cc

26.03.2010, L. Pandola, tag emlowen-V09-03-15
	    Changed order in some models' constructor to get rid of a valgrind 
	    warning (conditional jump or move depends on unitialized value(s)).

25.03.2010, S. Incerti, tag emlowen-V09-03-14
            Modified hydrogen correction in G4DNARuddIonisation.cc

25.03.2010, S. Incerti, tag emlowen-V09-03-13
            Dummy tag

18.03.2010, S. Incerti, tag emlowen-V09-03-12
            - Re-added vapor water shell constants to G4DNARuddIonisationModel.cc
            as suggested by Ziad.

18.03.2010, S. Incerti, tag emlowen-V09-03-11
            Extended low energy cover of G4DNA charge change processes

17.03.2010, L. Pandola, tag emlowen-V09-03-10
	    Added four new models (gamma ray models Compton, GammaConversion, 
	    PhotoElectric, Rayleigh), upgrades of G4Penelope from version2001 to 
	    version 2008. For now, 2008 models named as G4Penelope08xxxxModel
	    ** to be used with G4LEDATA version 6.10 **

16.03.2010, L. Pandola, tag emlowen-V09-03-09
            Modified public interface of G4PenelopeOscillatorManager (info to be used for 
            PenelopeIonisation)

15.03.2010, S. Incerti, tag emlowen-V09-03-08
            Modified electron correction in G4DNARuddIonisationModel.cc

15.03.2010, L. Pandola tag emlowen-V09-03-07
            Updated public interface of G4LivermorePhotoElectricModel. Removed 
	    possibility to use custom cuts for fluorescence/Auger. Main cuts from 
	    G4ProductionCutsTable are always used - for consistency.

15.03.2010, L. Pandola tag emlowen-V09-03-06
	    Clean-up in Penelope models (explicitely set Auger flag to false in 
            constructor)

19.02.2010, L. Pandola tag emlowen-V09-03-05
            Modification in calculations made by G4PenelopeOscillatorManager (Hartree
            factors for Penelope Compton Scattering)

17.02.2010, L. Pandola tag emlowen-V09-03-04
	    Updated interface for G4PenelopeOscillatorManager. Still *beta*

05.02.2010, S. Incerti, tag emlowen-V09-03-03
            Added initialisation to atomTotalCrossSection in G4hShellCrossSectionDoubleExp.cc.

07.01.2010, S. Incerti, tag emlowen-V09-03-02
            Improved way of testing material in Geant4-DNA models.

21.12.2009, L. Pandola, tag emlowen-V09-03-01
	    Added classes G4PenelopeOscillator* to manage multi-element atomic oscillators used 
            in Penelope Compton and Ionisation models. Already compliant with Penelope2008. 
            **Beta version at the moment**

21.12.2009, L. Pandola, tag emlowen-V09-03-00
	    Added a dummy ComputeCrossSectionPerAtom() method in G4PenelopeRayleighModel. 
            Never inkoved by tracking, issues a warning if users access it via G4EmCalculator.

10.12.2009, S. Incerti, tag emlowen-V09-02-68
            - Added vapor water shell constants to G4DNARuddIonisationModel.cc 
            as suggested by Ziad.

24.11.2009, A. Lechner tag emlowen-V09-02-67
            -G4IonParametrisedLossModel: Important bug fix to calculate ion
             ranges correctly if the same materials appears multiple times
             in tracking geometry with different production cuts (for example
             in different regions). (added UpdateRangeCache function,
             modified BuildRangeVector, ComputeLossForStep functions and
             removed GetRange function).

23.11.2009, A. Lechner tag emlowen-V09-02-66
            -G4IonParametrisedLossModel: Changed energy loss limit to smaller
             value (from 0.15 to 0.01) to avoid approximative loss description 
             in case of large steps.

20.11.2009, A. Lechner tag emlowen-V09-02-65
            -G4IonParametrisedLossModel: Added set-function for loss limit 
             parameter

12.11.2009, A. Lechner tag emlowen-V09-02-64
            -G4IonParametrisedLossModel: 
             *) Moved from original ICRU 73 classes to new class (G4Ion-
                StoppingData), which is capable of reading stopping power data 
                files stored in G4LEDATA (requires G4EMLOW6.8): With the new 
                tables the upper energy limit of ICRU 73 stopping powers is 
                increased to 1 GeV/nucleon. 
             *) Decision logic concerning stopping power scaling for heavy ions
                was entirely moved to class G4IonDEDXScalingICRU73.
             *) Introduced function for switching off scaling for heavy ions.
             *) Removed nuclear stopping from model since dedicated process is 
                available in standard EM package. 
             *) Minor fixes were applied in energy loss computation.
            - G4VIonDEDXScalingAlgorithm: Introduced additional argument for
              energy scaling function.
            - G4IonDEDXScalingICRU73: See model above. Adapted function
              according to interface changes in G4VIonDEDXScalingAlgorithm
            - G4IonDEDXHandler: Adapted function according to interface
              changes in G4VIonDEDXScalingAlgorithm. Using new build methods
              defined in G4VIonDEDXTable (contained in material package).

12.11.2009, S. Incerti tag emlowen-V09-02-63
            -removed memory leak in G4DNACrossSectionDataSet.cc

12.11.2009, S. Incerti tag emlowen-V09-02-62
            -added protection for secondary electron energy computation in
            G4DNABornIonisationModel.cc
            -proposed a faster computation of cross section max value

11.11.2009, A. Mantero tag emlowen-V09-02-61
            PIXE code cleaning for the Dec review and update of G4hLowEnIonisation
            in order to use new PIXE developments.

05.11.2009, G. Cosmo, tag emlowen-V09-02-60
            replaced usage of M_PI with pi from CLHEP, to fix compilation
            errors on Windows.

03.11.2009, S. Incerti, tag emlowen-V09-02-59
            modified low energy limit of e- elastic Champion Geant4-DNA model
            to be used with G4LEDATA version 6.8

02.11.2009, S. Incerti, tag emlowen-V09-02-58
            extended coverage of e- ionisation Geant4-DNA model 
            to be used with G4LEDATA version 6.8

23.10.2009, L. Pandola, tag emlowen-V09-02-57
            Switch atomic deexcitation on (by default) in Livermore PhotoElectric and 
	    Ionisation. It was on also for the former LowEnergy processes. It has been 
            accidentally switched off since tag emlowen-V02-02-27, probably.

22.10.2009, L. Pandola, tag emlowen-V09-02-56
	    Added ActivateAuger() method to Penelope Compton and Ionisation, so that 
	    all Penelope models have the same interface. 

21.10.2009, L. Pandola, tag emlowen-V09-02-55
            Cleaning up of Penelope Photoelectric, Compton and Ionisation 
            (atomic deexcitation flag now referred to G4VEmModel). Deexcitation now 
	    is by default active in Penelope models.

27.09.2009, N. Karakatsanis, tag emlowen-V09-02-54
            Added fixes to
            G4ecpssrKCrossSection.cc
            G4BremsstrahlungCrossSectionHandler.cc
            G4CrossSectionHandler.cc
            G4DNACrossSectionDataSet.cc
            G4eIonisationCrossSectionHandler.cc

25.09.2009, N. Karakatsanis, tag emlowen-V09-02-53
            New implementation for data loading and interpolation methods
            LoadData method now loads the data from G4EMLOW dataset and, then, calculates 
            the respective logarithmic values during initialization
            Both data formats (original and logarithmic) are loaded to EM datasets and used 
            later by interpolation methods to perform faster calculations.  
            LoadNonLogData method implements the old version for data loading and interpolation

24.09.2009, F.Longo, tag emlowen-V09-02-52
            implemented protection for infinite loops in Rayleigh
            process.  

30.08.2009, S. Incerti, tag emlowen-V09-02-51
            Extended high energy coverage of proton ionisation 
            (G4DNABornIonisationModel.cc) and excitation
            (G4DNABornExcitationModel.cc)
            Decreased temporarily high energy coverage of electron
            ionisation from 30 keV to 20 keV (G4DNABornIonisationModel.cc)
            The new data files are provided by Z. Francis.
            *** From now on G4LEDATA 6.7 should be used *** 

13.08.2009, S. Incerti, tag emlowen-V09-02-50
            Added G4_WATER NIST material to Geant4-DNA models

13.08.2009, S. Incerti, tag emlowen-V09-02-49
            Added verbose condition to all Geant4-DNA models

11.08.2009, S. Incerti, tag emlowen-V09-02-48
            Bug fix in G4DNABornIonisationModel (energy deposit was
            commented in last reference tag)

06.08.2009, A. Lechner, tag emlowen-V09-02-47
            Bug fix in G4IonDEDXHandler (access of physics vector was
            corrected, in compliance with new version of G4PhysicsVector 
            where hidden bin no longer exists).

06.08.2009, A. Lechner, tag emlowen-V09-02-46
            Bug fix in G4IonDEDXScalingICRU73 (initialization of cached values)

24.07.2009, V. Ivanchenko, tag emlowen-V09-02-45
            G4AtomicShell class is moved to utils subdirectory

23.07.2009, V. Ivanchenko, tag emlowen-V09-02-44
            G4VeLowEnergyLoss, G4eLowEnergyLoss, G4hLowEnergyLoss
            are adapted to modifications in G4PhysicsVector

23.07.2009, V. Ivanchenko, tag emlowen-V09-02-43
            Fixed path to G4LEDATA in G4ecpssrKCrossSection,
            G4ecpssrLCrossSection, G4DNACrossSectionDataSet;
            removed debug cout

26.06.2009, A. Mantero, tag emlowen-V09-02-41
            Compilation errors removal.

25.06.2009, A. Mantero, tag emlowen-V09-02-40
            Design update, Bug Fixes and models update for 
            atomic shell hadronic CS calulation.

02.06.2009, A.Lechner, tag emlowen-V09-02-39
            Bug fix in class G4IonDEDXScalingICRU73: Compilation
            error on Windows due to std::pow function was fixed. 

20.05.2009, L. Pandola, tag emlowen-V09-02-38
            Update Penelope models, G4LivermoreIonisationModel and 
            G4LivermoreBremsstrahlungModel; pointers deleted in the 
            Initialise() method are explicitely zeroed 
            (see tag emlowen-V09-02-37)

14.05.2009, L. Pandola, tag emlowen-V09-02-37
            Correct G4PenelopeBremsstrahlungModel to get rid of a crash 
            for re-inizialitation

12.05.2009, A.Lechner, tag emlowen-V09-02-36
            Added new scaling algorithm, to obtain heavy ion stopping powers
            for ions not covered by ICRU 73 report (scaled from existing 
            ICRU 73 data): G4IonDEDXScalingICRU73
            Included algorithm in ion model, G4IonParametrisedLossModel,
            extending therefore the applicability of the model to very heavy
            ions.

03.05.2009, S.Incerti, tag emlowen-V09-02-35
            Fixed compilation error in G4LivermorePolarizedComptonModel.cc

02.05.2009, S.Incerti, tag emlowen-V09-02-34
            Clean-up of G4LivermorePolarizedComptonModel and -Rayleigh models

02.05.2009, S.Incerti, tag emlowen-V09-02-33
            Added message to obsolete non-migrated Geant4-DNA cross section and final state classes

02.05.2009, S.Incerti, tag emlowen-V09-02-32
            Added message to obsolete non-migrated Livermore and Penelope classes           

02.05.2009, S.Incerti, tag emlowen-V09-02-31
            Fixed handling of compounds in G4LivermoreGammaConversionModel.cc

30.04.2009, S.Incerti, tag emlowen-V09-02-30
	    Removed annoying G4cout in G4AugerData.cc.
	    (AugerTransitionTable)
	    
29.04.2009, S.Incerti, tag emlowen-V09-02-29
            Increased energy range validity of e- elastic Champion model
            up to 10 MeV (Geant4-DNA process). 
            From this tag, G4LEDATA version 6.5 is needed.

29.04.2009, S.Incerti, tag emlowen-V09-02-28
            Fixed cross section computation bug in:
            G4DNAScreenedRutherfordElasticModel.cc
            G4DNAChampionElasticModel.cc

18.04.2009, V.Ivanchenko, tag emlowen-V09-02-27
            Cleanup of new model classes G4LivermoreBremsstrahlungModel,
            G4LivermoreComptonModel, G4LivermoreGammaConversionModel,
            G4LivermoreIonisationModel, G4LivermorePhotoElectricModel,
            G4LivermoreRayleighModel,G4PenelopeAnnihilationModel
            G4PenelopeBremsstrahlungModel, G4PenelopeComptonModel, 
	    G4PenelopeGammaConversionModel, G4PenelopeIonisationModel,
            G4PenelopePhotoElectricModel, G4PenelopeRayleighModel
              - defined high energy limit for a model in constructor
              - do not overwright default (zero) low energy limit of a model
              - do not change energy limits in Initiliation methods 
              - added MinEnergyCut method for models used for energy loss
              - do not change track status inside the model for charged particles
              - simplified initialisation
              - protect all printouts by verbosityLevel variable
              - removed MeanFreePath method and table
              - cleaned logic in applying of deexcitation module
              - use G4ElementSelector if possible
            G4ShellVacancy - substitute "set" varibale, 
                           - comment out destructor to avoid crash

02.04.2009, L. Pandola, tag emlowen-V09-02-26
            Fixed bug in G4PenelopeRayleigh.cc (calculation of mfp for compounds).
            Notice that G4PenelopeRayleighModel.cc was ok. The old process is 
	    going to be obsolete in a while.

25.03.2009, L. Pandola, tag emlowen-V09-02-25
 	    Fixed bug with momentum normalization in G4PenelopeBremsstrahlungModel.cc
            Fixed G4PenelopePhotoElectricModel.cc to avoid wrong Warnings

23.03.2009, L. Pandola, tag emlowen-V09-02-24
	    Same sa previous. For some reason emlowen-V09-02-23 didn't include 
            the updated files.

23.03.2009, L. Pandola, tag emlowen-V09-02-23
            - Added protections in G4eIonisationSpectrum and G4eIonisationParameters
              to avoid bug 1042.
            - From now on, G4LEDATA 6.4 should be used

19.03.2009, S. Incerti, tag emlowen-V09-02-22
            - changed energy range display for migrated Livermore photon processes

19.03.2009, S. Incerti, tag emlowen-V09-02-21
            - set default angular generator in G4LivermorePhotoElectric.cc as Sauter-Gavrila

19.03.2009, L. Pandola, tag emlowen-V09-02-20
	    - First fully tested version of G4LivermoreBremsstrahlungModel
	    From this tag on, all Livermore models are migrated.

18.03.2009, L. Pandola, tag emlowen-V09-02-19
	    - Removed G4Rayleigh to avoid duplication with G4RayleighScattering
            - Clean-up of G4RayleighScattering (e.g. removed un-necessary dependencies)

16.03.2009, A. Lechner, tag emlowen-V09-02-18
            - Replaced old version of G4IonParametrisedLossModel with newer one
            - Added G4IonDEDXHandler, which is a handler class used by the new
              G4IonParametrisedLossModel class
            - Added G4VIonDEDXScalingAlgorithm, which is used by G4IonDEDXHandler
            - Removed G4IonParametrisedLossTable (is replaced by G4IonDEDXHandler)

04.03.2009, S. Incerti, tag emlowen-V09-02-17
            - moved IsApplicable method for Geant4-DNA process classes from .hh to .cc

03.03.2009, S. Incerti, tag emlowen-V09-02-16
            - added gamma particle and energy range test in cross section computation
              to all Livermore photon processes 

16.02.2009, S. Incerti, tag emlowen-V09-02-15
            - added protections against FPE in G4hLowEnergyLoss.cc (see EM forum
              item 893) 

16.02.2009, S. Incerti, tag emlowen-V09-02-14
            - removed compilation warning in G4DNAEmfietzoglouExcitationModel.cc

16.02.2009, S. Incerti, tag emlowen-V09-02-13
            - improved energy limit display in Geant4-DNA model classes
            - commented InitialiseElementSelectors call.

16.02.2009, S. Incerti, tag emlowen-V09-02-12
            Made compatible with tag emutils-V09-02-00 the following files
            - G4DNAElastic.cc
            - G4DNAExcitation.cc 
            - G4DNAIonisation.cc 
            - G4DNAChargeDecrease.cc 
            - G4DNAChargeIncrease.cc 

14.02.2009, S. Incerti, tag emlowen-V09-02-11
            Added several corrections to migrated Geant4-DNA processes:
            - G4DNABornIonisationModel.cc
            - G4DNAEmfietzoglouExcitationModel.cc
            - G4DNARuddIonisationModel.cc
            - G4DNAIonisation.hh

10.02.2009, L. Pandola, tag emlowen-V09-02-10
	    - Added G4LivermoreIonisationModel, namely first implementation of 
	      LowEnergyIonisation in the new design

29.01.2009, L. Pandola, tag emlowen-V09-02-09
	    - Updated public interface of G4eIonisationCrossSectionHandler.cc in order to 
	      facilitate the migration from G4LowEnergyIonisation to G4LivermoreIonisationModel

22.01.2009, S. Incerti, tag emlowen-V09-02-08
            - Fixed compilation error problem & code syntax in DNA model classes

21.01.2009, S. Incerti, tag emlowen-V09-02-07
            - Updated Livermore photon processes classes for handling of compound materials
            - Added pointer removal protections
            - Involved classes are :
              G4LivermoreRayleighModel.cc
              G4LivermorePolarizedRayleighModel.cc
              G4LivermorePolarizedComptonModel.cc
              G4LivermorePhotoElectricModel.cc
              G4LivermoreGammaconversionModel.cc
              G4LivermoreComptonModel.cc

20.01.2009, S. Incerti, tag emlowen-V09-02-06
            Added 'kill particle without total energy deposit' feature for DNA charge change processes
            Involved files are : 
            - G4DNAProcess.icc, 
            - G4FinalStateProduct.hh,.cc,
            - G4FinalStateChargeDecrease.cc
            - G4FinalStateChargeIncrease.cc

20.01.2009, S. Incerti, tag emlowen-V09-02-05
            - Corrected energy limits in G4CrossSectionIonisationBornPartial.cc
            - Added proton case in G4CrossSectionExcitationMillerGreenPartial.cc
            - Added protection (waterExcitation.ExcitationEnergy) in G4CrossSectionExcitationMillerGreenPartial.cc

19.01.2009, S. Incerti, tag emlowen-V09-02-04
            Added angle initialisation in G4DNAScreenedRutherfordElasticModel

12.01.2009, S. Incerti, tag emlowen-V09-02-03
            Added preliminary migrated Geant4-DNA processes and models.

08.01.2009  L. Pandola, tag emlowen-V09-02-02
	    Edited G4PenelopePhotoElectric.cc and G4PenelopePhotoElectricModel.cc
	    to suppress a warning message from G4AtomicTransitionManager appearing 
	    for some elements (Oxygen ,Fluorine). This is due to the fact that 
            Penelope and G4AtomicTransitionManager databases may contain a different number 
	    of shells. Physics results are unchanged.

19.12.2008  L. Pandola, tag emlowen-V09-02-01
	    Added G4RayleighScattering process (G4VEmProcess) to 
	    describe Rayleigh scattering. This was not available within 
	    the Std package

15.12.2008  L. Pandola, tag emlowen-V09-02-00
	    Same as the previous one (emlowen-V09-01-46). I arrived too late.

15.12.2008  L. Pandola, tag emlowen-V09-01-46
	    Added G4PenelopeBremsstrahlungModel, namely bremsstrahlung according to Penelope 
	    model, migrated to the Std-design (inheriting from G4VEmModel). A few minor 
	    cleaning of G4PenelopeBremsstrahlungContinuous.cc and G4PenelopeIonisation.cc.
	    From this tag, ALL Penelope processes have been migrated.

12.12.2008   S. Incerti, tag emlowen-V09-01-45
             Upgrade to G4LogLogInterpolation_revision1c.cc

09.12.2008  S. Incerti, tag emlowen-V09-01-44
            Added protection to G4FinalStateElasticChampion.cc for angular treatment of XS 
            at 180*deg

09.12.2008   S. Incerti, tag emlowen-V09-01-43
             Contains G4PenelopeBremsstrahlungContinuous.hh/.cc from Luciano
             Contains G4LogLogInterpolation_revision1b.cc

09.12.2008   S. Incerti, tag emlowen-V09-01-42
             Upgrade to G4LogLogInterpolation_revision1b.cc

09.12.2008   S. Incerti, tag emlowen-V09-01-41
             Return to original G4LogLogInterpolation.cc/.hh class
             from tag emlowen-V09-01-20

08.12.2008   S. Incerti, tag emlowen-V09-01-40
             Added protection in G4LogLogInterpolation.cc class
             against null energy and cross section values

06.12.2008   S. Incerti, tag emlowen-V09-01-39
             Added vector initialization and EOF protection in G4FinalStateElasticChampion.cc
             Added EOF protection in G4FinalStateIonisationBorn.cc

06.12.2008   S. Incerti, tag emlowen-V09-01-38
             Updated G4LogLogInterpolation class (hh and cc) provided by
             Nicolas Karakatsanis (updated revision 1)

05.12.2008   S. Incerti, tag emlowen-V09-01-37
             Updated G4LogLogInterpolation class (hh and cc) provided by
             Nicolas Karakatsanis (revision 1)

05.12.2008   S. Incerti, tag emlowen-V09-01-36
             Updated low energy limits of Geant4-DNA e- models (Brenner-Zaider and Champion's
             elastic scattering and Emfietzoglou's excitation) 

05.12.2008   S. Incerti, tag emlowen-V09-01-35
             Added protection in G4FinalStateIonisationBorn.cc causing run-time error (valgrind with test20)

04.12.2008   L. Pandola, tag emlowen-V09-01-34
             Correction for G4PenelopeComptonModel: now the cross section table 
             calculated by the model corresponds to the original FORTRAN-Penelope. 
             The difference was only for compounds materials and below 1 keV, so 
             irrelevant for virtually all applications.
             First inclusion of G4PenelopeIonisationModel. 

24.11.2008   G. Cosmo, tag emlowen-V09-01-33
             Fixed compilation errors on gcc-4.3.2:
             o added required names for struct types (and using G4 prefix);
             o correctly initialise cached iterators (cannot be an integer!).

21.11.2008   A. Lechner, tag emlowen-V09-01-32
             added and tagged new stopping power model for ions, which by default
             uses ICRU 73 data tables. Following files are concerned:
             G4IonParametrisedLossModel.hh
             G4IonParametrisedLossModel.icc
             G4IonParametrisedLossModel.cc
             G4IonParametrisedLossTable.hh
             G4IonParametrisedLossTable.icc

06.11.2008   S. Incerti, tag emlowen-V09-01-31
             corrected bug in computation of diff cross section maximum in
             G4FinalStateElasticBrennerZaider.cc

30.10.2008   S. Incerti, tag emlowen-V09-01-30
             added & tagged new photon models compatible with standard EM design :
             
             -- Penelope models are provided by L. Pandola :
             G4PenelopeComptonModel.hh and .cc
             G4PenelopeGammaConversionModel.hh and .cc
             G4PenelopePhotoElectricModel.hh and .cc
             G4PenelopeRayleighModel.hh and .cc
             
             -- Livermore models are provided by S. Incerti : 
             G4LivermoreComptonModel.hh and .cc
             G4LivermoreGammaConversionModel.hh and .cc
             G4LivermorePhotoElectricModel.hh and .cc
             G4LivermorePolarizedComptonModel.hh and .cc
             G4LivermorePolarizedRayleighModel.hh and .cc
             G4LivermoreRayleighModel.hh and .cc

29.10.2008   S. Incerti, tag emlowen-V09-01-29
             - improved generation of scattering angle in G4FinalStateElasticChampion.cc

30.09.2008   S. Incerti, tag emlowen-V09-01-28
             - removed G4cout in G4LowEnergyCompton.cc (bug report #1026)

20.08.2008   S. Incerti, tag emlowen-V09-01-27
             - added KillParticle in G4FinalStateElasticChampion.cc below low energy limit
             - modified condition on low energy limit in G4CrossSectionElasticChampion.cc and G4FinalStateElasticChampion.cc
 
20.08.2008   S. Incerti, tag emlowen-V09-01-26
             - removed AddEnergyDeposit below low energy limit in G4FinalStateElasticBrennerZaider.cc (bug, thanks to Marion Bug)
             - removed AddEnergyDeposit below low energy limit in G4FinalStateExcitationEmfietzoglou.cc (idem)
             - removed AddEnergyDeposit below low energy limit in G4FinalStateIonisationRudd.cc (idem)
             - decreased low energy limit for e- to 12.61 eV in G4CrossSectionIonisationBorn.cc (from sigma_ionisation_e_born.dat table in $G4LEDATA/dna) instead of 25 eV
             - decreased low energy limit for e- to 12.61 eV in G4FinalStateIonisationBorn.cc (from sigma_ionisation_e_born.dat table in $G4LEDATA/dna) instead of 25 eV

16.07.2008   S. Incerti, tag emlowen-V09-01-25
             added preliminary process for positronium production
             from C. Champion's model
             G4CrossSectionPsCreationChampion.hh and .cc
             G4CrossSectionPsCreationChampionPartial.hh and .cc
             G4FinalStatePsCreationChampion.hh and .cc
             and updated G4DNAGenericIonsManager.cc
             *** Will work only from version 6.2 of G4EMLOW data

15.07.2008   S. Incerti, tag emlowen-V09-01-24
             added new elastic scattering process for electrons
             (Geant4 DNA) from C. Champion's model
             G4CrossSectionElasticChampion.hh and .cc
             G4FinalStateElasticChampion.hh and .cc
             *** Will work only from version 6.2 of G4EMLOW data

14.07.2008   S. Incerti, tag emlowen-V09-01-23
             cleaned and updated energy limits of the following 
             25 files (Geant4 DNA)

-G4CrossSectionChargeDecrease.hh and .cc
-G4CrossSectionChargeDecreasePartial.hh and .cc
-G4CrossSectionChargeIncrease.hh and .cc
-G4CrossSectionChargeIncreasePartial.hh and .cc
-G4CrossSectionElasticScreenedRutherfordHE.hh and .cc
-G4CrossSectionElasticScreenedRutherfordLE.hh and .cc
-G4CrossSectionExcitationBorn.hh and .cc
-G4CrossSectionExcitationBornPartial.hh and .cc
-G4CrossSectionExcitationEmfietzoglou.hh and .cc
-G4CrossSectionExcitationEmfietzoglouPartial.hh and .cc
-G4CrossSectionExcitationMillerGreen.hh and .cc
-G4CrossSectionExcitationMillerGreenPartial.hh and .cc
-G4CrossSectionIonisationBorn.hh and .cc
-G4CrossSectionIonisationBornPartial.hh and .cc
-G4CrossSectionIonisationRudd.hh and .cc
-G4CrossSectionIonisationRuddPartial.hh and .cc
-G4FinalStateChargeDecrease.hh and .cc
-G4FinalStateChargeIncrease.hh and .cc
-G4FinalStateElasticBrennerZaider.hh and .cc
-G4FinalStateElasticScreenedRutherford.hh and .cc
-G4FinalStateExcitationBorn.hh and .cc
-G4FinalStateExcitationEmfietzoglou.hh and .cc
-G4FinalStateExcitationMillerGreen.hh and .cc
-G4FinalStateIonisationBorn.hh and .cc
-G4FinalStateIonisationRudd.hh and .cc

30.06.2008   S. Incerti, tag emlowen-V09-01-22
             corrected wrong upper energy limit for :
             - hydrogen in G4CrossSectionIonisationRudd 
             - proton in G4ChargeDecrease

27.06.2008   S. Incerti, tag emlowen-V09-01-21
             - added two new classes for electron elastic scattering
             G4CrossSectionElasticScreenedRutherfordLE.cc and .hh below 200 eV
             G4CrossSectionElasticScreenedRutherfordHE.cc and .hh above 200 eV
             that should replace the G4CrossSectionElasticScreenedRutherfordHE class
             - raised lower energy limit of G4CrossSectionExcitationEmfietzoglou.cc up to 10 eV

27.06.2008   S. Incerti, tag emlowen-VO9-01-20
             - added protection against negative log argument in G4LogLogInterpolation.cc
             - added protection against energies above 200 eV in G4FinalStateElasticBrennerZaider.cc
             - removed verbose in G4CrossSectionChargeTransferExp.cc and in G4CrossSectionExcitationBorn.cc

26.06.2208   S. Incerti, tag emlowen-V09-01-19
             Added protection against FPE in G4hShellCrossSectionDoubleExp.cc

20.06.2008   S. Incerti, tag emlowen-V09-01-18
             Added 4 protections against FPE in G4hLowEnergyLoss.cc

11.06.2008   S. Incerti, tag emlowen-V09-01-17
             - added missing & for cosTheta and phi variables in G4FinalStateIonisationRudd.hh and .cc
             which were causing wrong angular distributions (bug fix)
             - removed annoying PrintData in G4CrossSectionExcitationBornPartial.cc

02.06.2008   S. Incerti, tag emlowen-V09-01-16
             Removed while(1) statement in G4FinalStateIonisationBorn.cc
             fixing compilation warning.
             Restored headers for G4PaulKCrossSection, G4OrlicLCrossSection
             and G4ecpssrCrossSection which were lost.

01.06.2008   F.Lei, tag emlowen-V09-01-15
	     Correction to the corrupted G4Augerdata.cc, and this tag is on top
	     of emlowen-V09-01-12! as emlowen-V09-01-13 is internal and incomplete.  
  
22.05.2008   F.Lei, tag emlowen-V09-01-14
	     Load the the complete Auger dataset on initialization	

06.05.2008   H.Ben Abdelouahed, tag emlowen-V09-01-12, emlowen-V09-01-13
             Semi-Empirical model implementation for L-SubShells-Cross-Section
             with protons projectiles

02.05.2008   MGP, tag emlowen-V09-01-11
             Added Doppler broadening in G4LowEnergyComptonPolarized 
             (Francesco Longo), same model as in G4LowEnergyCompton
             Added PIXE cross section, L shells, for protons in 
             G4OrlicLCrossSection (Haifa Ben Abdelwahed)
             Corrected compilation warnings as in message by
             G. Cosmo on 29/4/2008

24.04.2008   MGP, tag emlowen-V09-01-10
             Fix in Doppler broadening of G4LowEnergyCompton
             Attempts to fix floating point exceptions in 
             G4FinalStateElasticBrennerZaider and G4hLowEnergyLoss

22.04.2008   H.Ben Abdelouahed, tag emlowen-V09-01-09
             ECPSSR model implementation for K-Shell-Cross-Section
             with protons and alpha projectiles
 
18.03.2008   G.Cosmo, tag emlowen-V09-01-08
             Fixed compilation error in G4CrossSectionChargeTransferExp.cc
             for missing inclusion of <sstream>, detected on SUN-CC.

25.03.2008   MGP, tag emlowen-V09-01-07
             New charge transfer process by incident protons 
             (two cross section and one final state policy classes)

17.03.2008   MGP, tag emlowen-V09-01-06
             Doppler broadening added to G4LowEnergyCompton
             based on Y. Namito, S. Ban and H. Hirayama,
             NIM A 349, pp. 489-494, 1994

10.03.2008   MGP, tag emlowen-V09-01-05
             Developments for Doppler broadening concerning data management

10.03.2008   MGP, tag emlowen-V09-01-04
             Fixes to *DataSet files for better readability of the code
             Extensions to G4ShellData to deal with shell data relevant to 
             Doppler broadening simulation
 
07.03.2008   MGP, tag emlowen-V09-01-03
             Reverted to G4hLowEnergyIonisation.cc and G4hLowEnergyLoss.cc
             as in emlowen-V09-01-01

07.03.2008   MGP, tag emlowen-V09-01-02
             Operation for convenience of configuration management:
             updated G4hLowEnergyIonisation.cc and G4hLowEnergyLoss.cc
             to the head; the modifications to these two classes
             were an attempt to address a PRS report by A. Howard,
             but they proved ineffective and caused other problems;
             a tag including them is made to facilitate later retrieve

06.03.2008   MGP, tag emlowen-V09-01-01
             Restored readability of *DataSet* classes regards the
             indentation of the code

21.02.2008   MGP, tag emlowen-V09-01-00
             Bug fix in G4AtomicTransitionManager concerning
             total radiative and non radiative probabilities
             (fix provided by A. Mantero)

26.11.2007   MGP, tag emlowen-V09-00-28
             Cleaned up std:: in G4FinalStateIonisationBorn/Rudd

14.11.2007   MGP, tag emlowen-V09-00-27
             Correction to Problem Report 986 in G4AtomicDeexcitation

??.11.2007   Undocumented tag emlowen-V09-00-26

14.11.2007   MGP, tag emlowen-V09-00-25
             Workaround in G4DNAProcess to avoid meanFrePath=0 when
             cross section is DBL_MAX

13.11.2007   MGP, tag emlowen-V09-00-24
             Fixed calculation of local energy deposit in G4DNAProcess
             in the case when the primary particle is killed
             Minor code improvements in G4FinalStateIonisationBorn.cc.

12.11.2007   G.Cosmo, tag emlowen-V09-00-23
             Fixed trivial compilation error on WIN32-VC system in file
             G4FinalStateIonisationBorn.cc.

09.11.2007   MGP, tag emlowen-V09-00-22
             Added cross section and final state policy classes to configure
             a process to kill particles below threshold

09.11.2007   MGP, tag emlowen-V09-00-21
             Initialized data members missing initialization

09.11.2007   MGP, tag emlowen-V09-00-20
             Removed verbose printouts in Geant4-DNA processes

09.11.2007   MGP, tag emlowen-V09-00-19
             Fixed compilation problems on Windows

09.11.2007   MGP, tag emlowen-V09-00-18
             Fixed compilation problems on Solaris

08.11.2007   MGP, tag emlowen-V09-00-17
             Added Rudd ionisation

08.11.2007   MGP, tag emlowen-V09-00-16
             Added Born ionisation final state

08.11.2007   MGP, tag emlowen-V09-00-15
             Added Miller-Green excitation

08.11.2007   MGP, tag emlowen-V09-00-14
             Modified data file name in G4EMLOW5.1

08.11.2007   MGP, tag emlowen-V09-00-13
             Added charge increase/decrease Geant4-DNA cross sections
             and final states (code by S. Incerti + code review by MGP)

08.11.2007   MGP, tag emlowen-V09-00-12
             Removed obsolete G4DNA* files from CVS
 
22.10.2007   MGP, tag emlowen-V09-00-11
             Added G4CrossSectionIonisationBorn
             Excludes prototype G4DNA* classes (still available in CVS head)
             Pertinent G4DNA* classes included are: 
             G4DNAProcess (.hh .icc),
             G4DNACrossSectionDataSet (.hh .cc), 
             G4DNAGenericIonsManager (.hh .cc)

15.10.2007   MGP, tag emlowen-V09-00-10
             Added electron excitation (Emfietzoglou model),
             proton Born excitation, electron ionisation (Born) cross              section; modified G4DNACrossSectionDataSet to 
             remove inheritance from concrete base class introduced
             by a developer against the baseline design
             Obsolete G4DNA* classes not compliant with the design
             as in the TNS paper are still in this tag for convenience;
             they will be removed from the repository when the 
             migration to the design as in the paper is completed
             Goes with G4EMLOW5.0 (where a new dna/directory has been
             added containing Geant4-DNA data tables for interpolation)

13.10.2007   MGP, tag emlowen-V09-00-09
             Added Brenner-Zaider elastic scattering final state

12.10.2007   MGP, tag emlowen-V09-00-08
             Fully working Geant4-DNA electron elastic scattering, 
             screened Rutherford cross section and final state

12.10.2007   MGP, tag emlowen-V09-00-07
             Improved G4DNAProcess, G4FinalStateProduct

12.10.2007   MGP, tag emlowen-V09-00-06
             First core of Geant4-DNA physics compliant with design
             as in TNS paper: G4DNAProcess, G4FinalStateProduct, 
             G4eCrossSectionScreenedRutherford, G4DummyFinal State 
             (MG implementation)
 
12.10.2007   MGP, tag emlowen-V09-00-05
             Extended G4DNAFinalStateProduct to deal with primary
             particle modified in final state
             Modified G4DNAProcess.icc accordingly

12.10.2007   MGP, tag emlowen-V09-00-04
             Refactoring Geant4-DNA domain to be compliant with TNS paper
             Added G4DNAProcess and G4DNAFinalStateProduct

11.10.2007   MGP, tag emlowen-V09-00-03
             Identical to emlowen-V09-00-02, which apparently already 
             existed on some files (it is unclear where it originared from)

11.10.2007   MGP, tag emlowen-V09-00-02
             Re-update to atomic relaxation fixes as in  emlowen-V09-00-00
             emlowen-V09-00-00 was rejected because of a mismatch between 
             code and G4EMLOW data library
             This tag goes with G4EMLOW4.4

11.10.2007   MGP, tag emlowen-V09-00-01
             Fix to bug 965 of G4PenelopeRayleigh by L. Pandola

23.07.2007   MGP, tag emlowen-V09-00-00
             Deleted tag emlowen-V09-00-01 made by A.M. (no V-09-00-00 existed)
             Fixes by A.M. to handle Z=100 in the Livermore library
             and to correct Problem Report 933 (the latter fixes are not
             documented)

04.06.2007   MGP, tag emlowen-V08-03-03
             Tag on top of emlowen-V08-03-00a
             Updated license information in G4DNACrossSectionDataSet.cc

04.06.2007   G.Cosmo, tag emlowen-V08-03-00a
             Archived obsolete class G4LowEnergyBraggModel

30.05.2007   MGP, tag emlowen-V08-03-02
             Removed from CVS unused class G4LowEnergyBraggModel,
             which introduced never agreed dependency on standard
             G4VreEmModel
             Attempt to fix issue identified by VALGRIND related to
             PIXE model

25.05.2007   MGP, tag emlowen-V08-03-01
             Initialized static variables in G4hLowEnergyLoss;
             not sure whether this is correct, since this is old
             code moved from utils/, deprived of any documentation
             and with an evident fortran look. A design review
             is planned to take care of this domain in a proper way.
             Also included an updated version of G4BraggModel
             provided by V.I. due to an interface change: however
             this class is not used anywhere in the package, and is
             retained only for historical reasons; it is candidate to be
             trashed in the next design review.

16.05.2007   MGP, tag emlowen-V08-03-00
             First set of Geant4-DNA processes compliant with design
             documented in draft publication

19.10.2006   MGP, tag emlowen-V08-01-02
             Bug fixes in G4FluoData.cc

14.10.2006   MGP, tag emlowen-V08-01-01
             Developments and fixes for atomic deexcitation 

14.10.2006   MGP, tag emlowen-V08-01-00
             Cosmetics on code formatting for DNA processes

31.05.2006   G.Cosmo, tag emlowen-V08-00-06
             Added missing migration to std namespace for mathematical
             functions. Also required for allowing compilation on Windows
             platform.

25.05.2006   MGP, tag emlowen-V08-00-05
             Improved design and implementation of photoelectric angular 
             distribution models (related to atomic deexcitation)

25.05.2006   MGP, tag emlowen-V08-00-04
             Various fixes to the DNA processes to allow compilation with
             gcc 3.4.5. Some of the fixes are dummy implementations, or
             do not make sense physically; they should be revised in 
             a future dummy implementation. The present version of the
             DNA processes is meant as a first beta release, and is not
             suitable for physics application yet.

15.05.2006   MGP, tag emlowen-V08-00-03
             Improved design and implementation of photoelectric angular 
             distribution models

12.05.2006   MGP, tag emlowen-V08-00-02
             Same as emlowen-V08-00-00, with updated History

12.05.2006   MGP, tag emlowen-V08-00-01
             New developments: photoelectric angular distribution models
             The photoelectric angular distribution models have some
             temporary design features (function arguments passed
             by value etc.), and preliminary code implementation,
             (subset of the previous tag emlowen-V08-00-00 for
              incremental testing)

12.05.2006   MGP, tag emlowen-V08-00-00
             New developments: photoelectric angular distribution models
                               Geant4-DNA very lowE physics processes in water
             The photoelectric angular distribution models have some
             temporary design features (function arguments passed
             by value etc.), and preliminary code implementation
             The Geant4-DNA processes are in a beta-release status

20.12.2005   R.Capra, tag emlowen-V08-00-RC
             * Internal tag with latest developments in the DNA processes
               - Tested for build, run and plots verified

30.11.2005   G.Cosmo, tag emlowen-V07-01-14
             * Fixes for migration to <sstream> from obsolete <strstream>.
             * Trivial fix to G4LowEnergyGammaConversion for support of
               CLHEP-2.0.X series.
               NOTE: usage of RandBit can lead to event irreproducibility !

04.11.2005   MGP, tag emlowen-V07-01-13
             Fix in G4hLowEnergyIonistation (see note on 08.09.2005)
             On top of emlowen-V07-01-12

04.11.2005   MGP, tag emlowen-V07-01-12
             Fixes in atomic relaxation by A. Mantero
             On top of geant4-07-01-ref-04

21.09.2005   Ziad FRANCIS, tag emlowen-V07-01-11
             * Small corrections in G4DNAProtonBornExcitationProcess
             * ProtonBornExcitationCrossSection data file created
             * ProtonBornExcitation is tested an seems working fine.

21.09.2005   Ziad FRANCIS, tag emlowen-V07-01-10
             * G4DNARuddIonizationFinalStatesPolicy modifications so it
               becomes a common policy for HydrogenRuddIonization and
               ProtonRuddIonization. 
               So, G4DNAHydrogenRuddIonizationFinalStatesPolicy.hh .icc
               where deleted (useless).
             * G4DNAElectronBornExcitation Process implemented with data
               file "ElectronBornExcitationCrossSection" and tested by
               modified G4DNATest.cc
             * G4DNAProtonBornExcitation Process was implemented.
               ! It was NOT tested
               ! Data file "ProtonBornExcitation" is NOT ready yet

16.09.2005   Ziad FRANCIS, tag emlowen-V07-01-09
             * Implementation of Hydrogen Ionization Process in liquid water 
               according to the model of Eugene Rudd. Files created :
                    - G4DNAHydrogenRuddIonization.hh & .cc
                    - G4DNAHydrogenRuddIonizationFinalStatesPolicy.hh & .icc
                    - "RuddHydrogenIonizationCrossSection.dat" located in
                       ...lowenergy/test/ contains the total integrated
                       cross section.
             * G4DNATest was modified in order to take into account
               G4DNAHydrogenRuddIonization process.
             * Duplicated functions in G4DNARuddIonizationFinalStatesPolicy
               .hh & . icc  were removed and fixed.
             * G4DNARuddTotalCrossSectionPolicy.hh was removed (not needed).
             * G4DNAHydrogenRuddIonization Process was tested and seems
               working fine.      
                                                                 
15.09.2005   Ziad FRANCIS, tag emlowen-V07-01-08
             * Implementation of Proton Charge Increase process according to
               the model proposed by Dingfelder(2000). Files created :
                      - G4DNAChargeIncreaseInWater.hh .icc
                      - G4DNAProtonChargeIncrease.hh .cc
                      - G4DNAProtonChargeIncreaseTotalCrossSectionPolicy.hh
                                                                        .icc
                      - G4DNAProtonChargeIncreaseFinalStatesPolicy.hh .icc
             * G4DNATest was modified in order to take into account this
               proton charge increase process in liquid water.
             * G4DNAProtonChargeIncrease was tested and seems to be OK!
 
15.09.2005   Ziad FRANCIS, tag emlowen-V07-01-07
             * Implementation of slow protons Charge Transfer process
               according to the model used by M.Dingfelder(2000). Files
               created :
                      - G4DNAChargeDecreaseInWater.hh .icc
                      - G4DNAProtonChargeDecrease.hh .cc
                      - G4DNAProtonChargeDecreaseTotalCrossSectionPolicy.hh
                                                                        .icc
                      - G4DNAProtonChargeDecreaseFinalStatesPolicy.hh .icc
             * G4DNATest was modified in order to take into account
               ProtonChargeDecrease process testing.
             * G4DNAProtonChargeDecrease was Tested and seems working fine !

13.09.2005   Ziad FRANCIS, tag emlowen-V07-01-06
             * Implementation of slow protons (<500keV) ionization process according
               to the Rudd semi empirical model, files created :
                          - G4DNAIonizationInWater.hh .icc
                          - G4DNAProtonRuddIonizationFinalStatesPolicy.hh .icc
                          - G4DNAProtonRuddIonization.hh .cc
             * Total integrated cross sections are in a data file
               "RuddProtonIonizationCrossSection.dat"
             * G4DNATest was modified in order to take into account this
               ProtonRuddIonization process which was tested in a first
               approach.
             
12.09.2005   R.Capra, tag emlowen-V07-01-05
             * Minor changes to G4DNATest in order to corectly support 
               secondaries. 
             * Minor changes to G4VDNAProcessInWater in order to corectly
               kill particles with secondaries

10.09.2005   R.Capra, tag emlowen-V07-01-04
             * Minor fixes to G4DNATotalCrossSectionFromFilePolicy. It had
               compilation errors.

08.09.2005   R.Capra, tag emlowen-V07-01-03
             * There is a serius bug in G4hLowEnergyLoss. There are
               a lot of static data members. Moreover there are static
               vectors with fixed dimensions.
               The vector dimension has been resized from 10 to 100 in order
               to avoid memory corruption errors caused by code in 
               src/G4hLowEnergyIonisation.cc.
               The bug cannot be considered properly fixed. It is still
               pending
             * test/G4DNATest.cc has been upgraded in order to manage
               processes with more than one secondary particle

26.07.2005   Ziad FRANCIS, tag emlowen-V07-01-02
             * G4DNAEmfietzoglouExcitationTotalCrossSectionPolicy.hh and 
               G4DNAEmfietzoglouExcitationTotalCrossSectionPolicy.icc were
               tested using G4DNATest
             * G4DNATest upgrade in order to manage G4DNAElectronExcitation
               testing
             * Implementation of Electron Excitation process
               (G4DNAElectronExcitation)

20.07.2005   Riccardo Capra, tag emlowen-V07-01-01
             * Small corrections in G4DNATotalCrossSectionFromFilePolicy
             * Implementation of DNA excitation processes for protons and
               alphas.
               - Processes tested (preliminary test). Protons seems fine
                 while alpha particle total cross section differs from
                 plots in the reference documents
             * G4DNATest upgrade in order to manage the new implemented
               processes and in order to select the particle type from
               command line

07.07.2005   Riccardo Capra, tag emlowen-V07-01-00
             * G4DNAElectronElasticBrenner and G4DNAElectronElasticEmfietzoglou
               were tested with G4DNATest
               - Some minor correction to the related classes
             * Implementation of the total cross-section policy that allows
               reading file tables (tested)
             * Correction in the Save method of the G4(*)EMDataSet classes
               - The previous tag has a problem with units

24.06.2005   Riccardo Capra, tag emlowen-V07-00-13
             * Changes to G4(*)EMDataSet classes according to the design
               iteration:
              - LoadData is now a public virtual method
              - SaveData is a new method that allows data saving in the same
                format of LoadData.
              - Constructors with the filename cannot be used anymore. They
                are substituted with constructors that generates an empty
                data set
              - Energies and Data can be set after de construction with
                the new SetEnergiesData

             * Changes to G4VLowEnergyDiscretePhotonProcess in order to
               inherit from G4VLowEnergyTestableDiscreteProcess.
               - GetMeanFreePath and PostStepDoIt methods of all discrete
                 processes made inherit from G4VLowEnergyTestableDiscreteProcess 
                 could be (partially) tested with a unique testing code now.
             
             * DNA code changed according to the design iteration tha now
               uses templated classes
               
             * Code builds and links the test codes unde Linux.
               - G4(*)EMDataSet and DNA classes test are still in progress
               - Some minor changes could be done to the structures used to
                 configure the policy-based processes

??.??.????   ?, tag emlowen-V07-00-12

31.05.2005   MGP, tag emlowen-V07-00-11
             Fix to Penelope ionisation (for atomic deexcitation?)
             contributed by A. Mantero

31.05.2005   MGP, tag emlowen-V07-00-10
             Sauter angular distribution fixed in G4PenelopePhotoelectric
             (contributed by L. Pandola)

31.05.2005   Riccardo Capra, emlowen-V07-00-09, implementation of 
             the DNA elastic scattering in water.

             A.M., tag emlowen-V07-00-08
             Not documented

20.05.2005   MGP, tag emlowen-V07-00-07
             Small design fixes related to PolarizedRayleigh on top 
             of the previous tag

20.05.2005   MGP, tag emlowen-V07-00-06
             New low energy polarised Rayleigh scattering process
             (G4LowEnergyPolarizedRayleigh) developed by Riccardo Capra
             To be paired to test14-V07-00-00 for integration testing

20.05.2005   MGP, tag emlowen-V07-00-05
             Fix in G4hICRU49Nuclear.cc G4hZiegler1985Nuclear.cc, 
             provided by V. Ivanchenko

20.05.2005   MGP, tag emlowen-V07-00-04
             Bug fix in G4LowEnergyPolarizedCompton, provided by R. Capra

20.05.2005   MGP, tag emlowen-V07-00-03
             Bug fix in AtomicDeexcitation concerning the Auger effect,
             provided by A. Mantero

20.05.2005   MGP, tag emlowen-V07-00-02
             Bug fix in PenelopeIonisation provided by L. Pandola (PRS 729)
             The solution is correct, but it should be revisited for 
             improved implementation later             

             R.C., tag emlowen-V07-00-01
             Undocumented              

             A.M., tag emlowen-V07-00-00
             Undocumented

10.12.2004   G.Cosmo, tag emlowen-V06-02-15
             Replaced M_PI with CLHEP's pi.

10.12.2004   MGP, tag emlowen-V06-02-14
             Bug fix in G4AtomicDeexcitation (by A. Mantero)

02.12.2004   MGP, tag emlowen-V06-02-13
             Migration to <cmath>
 
01.12.2004   MGP, tag emlowen-V06-02-12
             Fixes for uninitialized variables in Auger classes provided
             by A. Mantero.

01.12.2004   MGP, tag emlowen-V06-02-11
             On top of emlowen-V06-02-09, with fixes for missing
             ParticleChange migration changes, not spotted by
             the migration script

01.12.2004   Alfonso Mantero, tag emlowen-V06-02-10
             Fixes for uninitialized variables spotted by Valgrind
             Introduces new files still on the head by mistake

30.11.2004   MGP, tag emlowen-V06-02-09
             Corrected uninitialized variables in G4hShellCrossSection*,
             spotted by Valgrind

18.11.2004   MGP, tag emlowen-V06-02-08
             Cleaned up code in G4hShellCrossSection* 
             (further code review urgently needed!) 

23.11.2004   Mark Donszelmann, tag emlowen-V06-02-07
             Fix for compilation error of G4hShellCrossSectionDoubleExp.cc
             on Linux-icc, WIN32-VC, SUN-CC

18.11.2004   MGP, tag emlowen-V06-02-06
             Migration for new ParticleChange

18.11.2004   MGP, tag emlowen-V06-02-05
             Improved Paul&Sacher PIXE model added; it becomes the default one

18.11.2004   MGP, tag emlowen-V06-02-04
             First Paul&Sacher PIXE model becomes the default one

17.11.2004   MGP, tag emlowen-V06-02-03
             Software improvement in G4PenelopeCompton (by L. Pandola)

17.11.2004   MGP, tag emlowen-V06-02-02
             Revision of G4LowEnergyPhotoelectric to allow for new
             development of precise angular distributions

12.11.2004   MGP, tag emlowen-V06-02-01
             Fixes to tables manipulation, effective charge, graphite
             problem and Bremsstrhalung low energy edge of the
             spectrum by Vladimir Ivanchenko 

27.09.2004   MGP, tag emlowen-V06-02-00
             Fixes for compilation with gcc 3.4 (mostly by Gabriele)

07.06.2004   G.Cosmo, tag emlowen-V06-01-02
             Fix in G4hShellCrossSectionExp for compilation error on WIN32-VC.

01.06.2004   MGP, tag emlowen-V06-01-01
             Bug fix for Barkas effect   

01.06.2004   MGP, tag emlowen-V06-01-00
             Bug fix in energy loss concerning positrons handled by Penelope   
  
19.05.2004   MGP, tag emlowen-V06-00-11
             New model for PIXE (by Simona Saliceti)

19.05.2004   MGP, tag emlowen-V06-00-10
             First iteration towards new models for photoelectric 
             angular distribution: design iteration and re-implementation
             of re-implementation of non-polarized Sauter-Gavrila 
             distribution (K-shell approximation)" by Pedro Rodrigues 
             and Andreia Trindade

23.03.2004   G.Cosmo, tag emlowen-V06-00-09
             Fix in G4PenelopeCompton for compilation error on WIN32-VC.

15.03.2004   MGP, tag emlowen-V06-00-08
             Fix in G4PenelopeRayleigh related to PR 605
             Bug fix in G4PenelopeIonisation
             Performance improvement in Penelope processes

15.03.2004   MGP, tag emlowen-V06-00-07
             Performance improvement in G4Generator2BN

12.03.2004   MGP, tag emlowen-V06-00-06
             Fixed compilation warnings

12.03.2004   MGP, tag emlowen-V06-00-05
             G4PolarizedRayleigh removed

12.03.2004   MGP, tag emlowen-V06-00-04
             Contains G4PolarizedRayleigh, which has compilation problems,
             but no maintenance by authors, for future retrieval

11.03.2004   MGP, tag emlowen-V06-00-03
             Bug fixes in G4PenelopeCompton and G4PenelopeIonisation

11.03.2004   MGP, tag emlowen-V06-00-02
             Bug fix in G4IonisationParameters

26.01.2004   MGP, tag emlowen-V06-00-01
             Optimization of Bremsstrahlung angular generators,
             provided by LIP group

26.01.2004   MGP, tag emlowen-V06-00-00
             Fixed memory leaks in G4PenepoleInterpolator and
             G4PenelopeIonisation

18.11.2003   MGP, tag emlowen-V05-02-10
             Performance optimization in Bremsstrahlung angular distribution

18.11.2003   MGP, tag emlowen-V05-02-09
             Performance optimisation in Penelope Bremsstrahlung +
             fix for local variable hiding a data member in G4PenelopeIonisation

18.11.2003   MGP, tag emlowen-V05-02-08
             Fixed compilation problem on Windows in G4Generator2BS.cc
 
10.11.2003   MGP, tag emlowen-V05-02-07
             Fix to Penelope Bremsstrahlung angular distribution
  
06.11.2003   MGP, tag emlowen-V05-02-06
             New processes for electrons and positrons according to 
             Penelope models

06.11.2003   MGP, tag emlowen-V05-02-05
             Improved user interface to select Bremsstrahlung angular
             distribution models
             System test coverage in test14-V05-02-01

05.11.2003   MGP, tag emlowen-V05-02-04
             New models of Bremsstrahlung angular distribution (2BN, 2BS),
             provided by LIP group

05.11.2003   MGP, tag emlowen-V05-02-03
             Bug fix in G4hLowEnergyIonisation (provided by V. Ivanchenko)

05.11.2003   MGP, tag emlowen-V05-02-02
             Bug fix in G4AtomicDeexcitation (provided by A. Mantero)
             
?            A. Mantero, tag emlowen-V05-02-01
             ?

?            H. Kurashige, tag emlowen-V05-02-00
             ?

25.06.2003   G.Cosmo, tag emlowen-V05-01-04
             Added disclaimer of liability where needed.
             Fixed argument to pow() in G4LinLogLogInterpolation.cc
             and G4LogLogInterpolation.cc to allow for porting on .NET 7.1 compiler.

20.05.2003   MGP, tag emlowen-V05-01-03
             Removed memory leaks in G4PenelopeCompton and 
             G4PenelopeBremsstrahlung
             Corrected design flaw in private interface of 
             G4eBremsstrahlungSpectrum

20.05.2003   MGP, tag emlowen-V05-01-02
             Design iteration in G4LowEnergyBremsstrahlung: abstract class for 
             angular distribution + implementation in G4ModifiedTsai
             (physics unchanged)

20.05.2003   MGP, tag emlowen-V05-01-01
             G4PenelopeCompton triggers atomic relaxation

20.05.2003   MGP, tag emlowen-V05-01-00
             Removed compilation warnings related to config-V05-01-00

26.04.2003   VI, tag emlowen-V05-00-17
             Fixes of stepLimit 

24.04.2003   MGP, tag emlowen-V05-00-16
             Fixes related to "cuts-per-region"

24.04.2003   MGP, tag emlowen-V05-00-15
             Fixes for "final range" and fix in G4VeLowEnergyLoss
             related to "cuts per region"

17.04.2003   MGP, tag emlowen-V05-00-14
             Bug fix to the Auger effect, in response to user report

17.04.2003   MGP, tag emlowen-V05-00-13
             Modifications related to "cuts per region" by VI as below
             Bug fix to G4LowEnergyGammaConversion (angular distribution)

12.04.2003   VI migration to cut per region for fluo AlongStep
             G4ShellVacancy, G4hLowEnergyIonisation, G4LowEnergyIonisation

28.03.2003   G.Cosmo, tag emlowen-V05-00-12
             Fixed compilation errors on SUN-CC for files:
              G4PenelopeBremsstrahlung.cc, G4PenelopeBremsstrahlungAngular.cc,
	      G4PenelopeBremsstrahlungContinuous.cc, G4PenelopeInterpolator.cc.
             Variables defined in for-loops scope were used outside scope!

27.03.2003   G.Cosmo, tag emlowen-V05-00-11
             Fixed usage of 'abs' in G4PenelopeInterpolator.cc and
	     G4PenelopeBremsstrahlungContinuous.cc to allow porting
             on WIN32-VC platform. 'abs' should not be included in
             the std namespace.

19.03.2003   MGP, tag emlowen-V05-00-10
             Includes the two minor items below, on top of emlowen-V05-00-09

10.03.2003   VI remove cut per material warning
             VI use SutType for ions

28.02.2003   VI Minor design iteration on Bremsstrahlung, to accomodate
             variable name of file with parameters

26.02.2003   G.Cosmo, tag emlowen-V05-00-09
             Fixed usage of 'abs' in G4PenelopeCompton.cc to allow porting
             on WIN32-VC platform. 'abs' should not be included in the std
             namespace.

24.02.2003   MGP, tag emlowen-V05-00-08
             Small fixes related to Penelope processes for photons

22.02.2003   MGP, tag emlowen-V05-00-07
             Porting Penelope processes for photons to SUN

22.02.2003   MGP, tag emlowen-V05-00-06
             Minor design iteration on Bremsstrahlung, to accomodate
             variable number of parameters compatible with Penelope
             processes

22.02.2003   MGP, tag emlowen-V05-00-05
             New Ziegler2000 parameterisation for G4hLowEnergyIonisation
             added by VI

12.02.2003   MGP, tag emlowen-V05-00-04
             Corrected compilation error in G4LowEnergyLoss in tags V05-00-02/3
             Migrated Penelope processes to cuts-per-region 
             Removed some compilation warnings

11.02.2003   MGP, tag emlowen-V05-00-03
             First tag including Penelope processes for photons and related
             unit tests, implemented by Luciano Pandola

11.02.2003   MGP, tag emlowen-V05-00-02
             Included minor editing of header files in the cut-per-region
             migration and protection of energy loss fluctuations by VI 

05.02.2003   CG, tag emlowen-V05-00-01
             Removed redundant inclusion of headers for units and constants.
             Now using directly CLHEP headers. Affected files:
             G4QAOLowEnergyLoss.cc and few unit test .cc files.

24.01.2003   MGP, tag emlowen-V05-00-00
             Included changes by VI for migration to cuts-by-region aware
             processes.

10.12.2002   MGP, tag emlowen-V04-01-09
             VI G4hLowEnergyIonisation.cc - antiprotons: free electron gas 
             model replaces constant extension of quantum oscillator model 
             at low energies (< 25 keV), as for protons

28.11.2002   MGP, tag emlowen-V04-01-08
             Update of G4ComptonTest and test/GNUmakefile by A. Pfeiffer
             for AIDA3/Anaphe5

18.11.2002   MGP, tag emlowen-V04-01-07
             Bug fix in G4BremsstrahlungParameters, to load EEDL correctly
             (correction for PRS 430)

08.11.2002   MGP, tag emlowen-V04-01-06
             New model for angular distribution in Rayleigh by Gerardo
             Depaola and Francesco Longo; corrects PRS problem 406

08.11.2002   MGP, tag emlowen-V04-01-05
             VI optimisation of tables in G4LowEnergyIonisation,
                G4eLowEnergyLoss, G4hLowEnergyLoss, G4hLowEnergyIonisation

08.10.2002   MGP, tag emlowen-V04-01-04
             VI G4hLowEnergyIonisation.cc - clean up fluo flag definition and init
             VI G4hIonEffChargeSquare.cc - fix in charge definition
             VI G4hShellCrossSection.cc - fix in shell cross section for hadrons
             VI G4hLowEnergyLoss.cc - clean up inverse range table build
             VI G4VeLowEnergyLoss.cc - clean up inverse range table build
             VI G4hLowEnergyIonisation.cc - clean up energy ranges for models
             VI G4LowEnergyIonisation.cc  - remove ActivateFluorescence from 
                                            SetCut.. methods
                
27.08.2002   CG,VI, tag emlowen-V04-01-03
             A. Mantero fix leakage in G4AtomicTransition.cc

30.07.2002   CG,VI, tag emlowen-V04-01-02
             VI fix to G4LowEnergyIonisation.cc, for restricted energy loss

30.07.2002   CG,VI, tag emlowen-V04-01-01
             CG fix to G4VCrossSectionHandler.cc, to fix compilation problems
                on DEC-cxx non-ISO.
             VI fix to G4AugerData.cc, to clean warnings on gcc-3.1 and optimise
                load of data in memory.

15.06.2002   MGP, tag emlowen-V04-01-00
             VI Bug fix in G4eEnergySpectrum 
             VI Bug fix in G4VCrossSectionHandler, connected modifications in
                other handlers

15.06.2002   MGP, tag emlowen-V04-00-17
             VI Bug fix in fluctuations in G4hLowEnergyIonisation 
             VI Removed duplicate member function to activate fluorescence

10.06.2002   MGP, tag emlowen-V04-00-16
             fStopAndKill moved to fStopAndAlive in G4hLowEnergyIonisation
             to satisfy UR for activation of further processes for ions
             (UR by UKDM)

07.06.2002   MGP, tag emlowen-V04-00-15
             Fixes to Rayleigh by Francesco Longo and Gerardo Depaola (PRS 371)

07.06.2002   MGP, tag emlowen-V04-00-14
             Added comments for Software Reference Manual

03.06.2002   MGP, tag emlowen-V04-00-13
             Fixes to Auger by Alfonso Mantero
             Goes with new version of G4LEDATA G4EMLOW1.1

03.06.2002   MGP, tag emlowen-V04-00-12
             Introduce Auger implementation (previously handled as
             local energy deposit)

02.06.2002   MGP, tag emlowen-V04-00-11
             VI Fixes in Bremsstrahlung - interpolation above 10 MeV
             VI Change parametrisation of e- ionisation - 24-parameters
                 for each shell are used. Corresponding change is
                 sampling and integration
             VI Add excitation cross sections and energy 
             New interpolation algorithm
             Goes with new version of G4LEDATA G4EMLOW1.0

02.06.2002   MGP, tag emlowen-V04-00-10
             Improvements to PolarizedCompton by F. Longo and G. Depaola

02.06.2002   MGP, tag emlowen-V04-00-09
             Fixed max length of ntuple variable names for HBOOK
             in test/G4ComptonTest
             Updates in unit tests and in hTest by V.I.

28.05.2002   MGP, tag emlowen-V04-00-08
             Code and minor design improvements deriving from reviews,
             inspections and Code Wizard

28.05.2002   MGP, tag emlowen-V04-00-07
             Added protection in G4eIonisationSpectrum

28.05.2002   MGP, tag emlowen-V04-00-06
             G4ComptonTest and test/GNUmakefile updated to AIDA 2.2 and
             Anaphe 4.0.n

19.04.2002 - MGP, tag emlowen-V04-00-05
             Fixed compilation warnings; added pointer protection in
             G4eLowEnergyLoss

18.04.2002 - MGP, tag emlowen-V04-00-04
             Modification to G4VCrossSectionHandler and 
             G4LowEnergyPhotoElectric to fix a problem

18.04.2002 - VNI
             G4LowEnergyPhotoElectric: fix in Fluo part + MeanFreePath
             calculation using crossSectionHandler and cross sections
             directly 

18.04.2002 - MGP, tag emlowen-V04-00-03
             Modification to table calculation for GenericIon as below

09.04.2002 - VNI
             For GenericIons all tables are calculated once now 

03.04.2002 - MGP, tag emlowen-V04-00-02
             Option to activate atomic deexcitation in ionisation processes

28.03.2002 - VNI
             Add Fluorescence flag to electron and hadron ionisation 

27.03.2002 - VNI, tag emlowen-V04-00-01
             Bug fix in hadron Fluo  and in deexcitation 

28.02.2002 - MGP, tag emlowen-V04-00-00
             V.Ivanchenko bug fix for GenericIons 

30.11.2001 - MGP, tag emlowen-V03-02-49
             Major physics improvement in electron processes by V.I.
             Significant improvement of performance
             Requires new version of data: G4EMLOW0.5

28.11.2001 - MGP, tag emlowen-V03-02-48
             Fix for compilation on Windows 

27.11.2001 - MGP, tag emlowen-V03-02-47
             Fix by V.I. related to the removal of static inline functions

23.11.2001 - MGP, tag emlowen-V03-02-46
             Removed static inline functions, as requested by G. Cosmo
             to satisfy porting requirements

15.11.2001 - MGP, tag emlowen-V03-02-45
             Bug fix in G4FluoData 
             Physics improvement in Bremsstrahlung
             Modified warning message in G4hLowEnergyIonisation
             Goes with new database version G4EMLOW0.4

09.11.2001 - MGP, tag emlowen-V03-02-44
             Example for using analysis in test/LowEnTest, based on 
             Ramon's XrayTel

09.11.2001 - MGP, tag emlowen-V03-02-43
             Fixed name in test/processTest/GNUmakefile causing
             problems with library map

08.11.2001 - MGP, tag emlowen-V03-02-42
             Modifications to be compliant with the unsupported, 
             deprecated "cuts per material" 
             Added G4CutsPerMaterialWarning functor to warn users
             WARNING: LowE processes are not supported if using different
             cuts for different materials

06.11.2001 - MGP, tag emlowen-V03-02-41
             Identical to emlowen-V03-02-40
             Redone because the tag aborted before completion

06.11.2001 - MGP, tag emlowen-V03-02-40
             Performance improvement in electron processes
             Some clean up of code (include/forward class declarations,
             coding style guidelines etc.)
             First implementation of a generic unit test, with AIDA/Lizard
             analysis in test/processTest

01.11.2001 - MGP, tag emlowen-V03-02-39
             PIXE introduced in G4hLowEnergyIonisation

29.10.2001 - MGP, tag emlowen-V03-02-38
             Bug fixes in new code
             Generic unit test for e/photon processes in test/processTest
             (analysis still to be added)

28.10.2001 - MGP, tag emlowen-V03-02-37
             Fixed compilation warnings on Linux and HP
             Improved code style

26.10.2001 - MGP, tag emlowen-V03-02-36
             Bug and memory leak fixes in the new electron classes

26.10.2001 - MGP, tag emlowen-V03-02-35
             Swapped old/new electron processes

25.10.2001 - MGP, tag emlowen-V03-02-34
             Bug fixes in the new classes related to Bremsstrahlung and 
             e/h Ionisation             

25.10.2001 - MGP, tag emlowen-V03-02-33
             G4LowEnergyPolarizedCompton moved to new design
             Many bug fixes in G4eIonisationParameters and G4BremsstrahlungParameters
             New classes for shell cross sections for proton-induced fluorescence 
             Fluorescence introduced in temporary class G4hLowEnergyIonisation
             Fluorescence introduced in the continuous part of electron
             ionisation in G4eLowEnergyLoss and temporary G4LowEnergyIonisationVI

18.10.2001 - MGP, tag emlowen-V03-02-32
             Same as previous one, with on top fixes to G4BremsstrahlungParameters.cc
	     and G4eIonisationParameters.cc by G. Cosmo for compatibility with 
             geant4-03-02-ref-06 in view of STL migration

18.10.2001 - MGP, tag emlowen-V03-02-31
             Added member function in G4eLowEnergyLoss and G4VLowEnergyIonisationVI
             for generation of atomic deexcitation products in the continuous part

18.10.2001 - MGP, tag emlowen-V03-02-30
             Electron processes: contributions to the implementation by V.I.
                                 revision of code quality and consistency
                                 with design by MGP

18.10.2001 - MGP, tag emlowen-V03-02-29
             Modification of G4hNuclearStoppingModel and 
	     G4hParametrisedLossModel by G. Cosmo required for
             compatibility with materials-V03-02-04

12.10.2001 - MGP, tag emlowen-V03-02-28
             Cosmetics in the source code (FALSE/TRUE moved to false/true)
             and update of all tests to new materials migrated to STL

11.10.2001 - MGP, tag emlowen-V03-02-27
             Further revision of the new code in the previous tag
             Restored G4LowEnergyIonisation and G4LowEnergyBremsstrahlung 
             as in emlowen-V03-02-25; new versions as in emlowen-V03-02-26
             renamed temporarily to allow for parallel development
             Removed references to Rogue Wave and STL interface from
             test/LowEnTest/ and test/fluoTest/

10.10.2001 - MGP, tag emlowen-V03-02-26
             Code for implementation of design iteration for electrons 
             by V. Ivanchenko
             Major revision of new code to improve code quality and consistency
             with design by MGP
             Since the new code does not respect the design and broke system 
             test and user code, this tag is only for internal debugging 
             purpose and should not be used by developers

09.10.2001 - MGP, tag emlowen-V03-02-25
             Identical to the previous one, but restored G4VDataSetAlgorithm
             (corrupted in cvs update?)

08.10.2001 - MGP, tag emlowen-V03-02-24
             Modified G4CrossSectionHandler to inherit from base class
             Minor design iteration in G4VEMDataSet and G4VDataSetAlgorithm
             Encapsulated range test to generate secondaries into a 
             strategy pattern; implemented in photon processes

04.10.2001 - MGP, tag emlowen-V03-02-23
             Fluorescence according to the new design introduced 
             into e- ionisation (contribution to PostStepDoIt) 
             by E. Guardincerri

26.09.2001 - MGP, tag emlowen-V03-02-22
             Workaround to support deficiencies of ObjectSpace in 
             implementation of STL pair 

25.09.2001 - MGP, tag emlowen-V03-02-21
             Workaround to support deficiencies of ObjectSpace in 
             implementation of STL pair (wrongly tagged)

24.09.2001 - MGP, tag emlowen-V03-02-20
             Minor modifications to make the lowenergy category co-work
             with both materials-V03-02-03 and materials as 
             in geant4-03-02-ref-03

23.09.2001 - MGP, tag emlowen-V03-02-19
             Same as previous one + migration to materials-V03-02-03 (STL)

23.09.2001 - MGP, tag emlowen-V03-02-18
             New class to generate shell vacancies in continuous part
             of processes by E. Guardincerri
             Renamed old photon processes (pre-design iteration) to
             G4LowEnergyOld; to be kept for a limited period for convenience
             of regression testing
             Fixed various STL problems found with HP compiler
             Added protection in G4LowEnergyPhotoElectric to avoid
             generating photons causing negative energy balance

21.09.2001 - MGP, tag emlowen-V03-02-17
             G4LowEnergyPhotoElectric moved to the implementation
             according to the new fluo+data design 
             [Test version G4LowEnergyPhotoElectricMG removed]
             Fixed warning for energy outside allowed range in G4EMDataSet
             Update to test/GNUmakefile, G4ComptonTest.cc by A. Pfeiffer
             Minor cosmetics

19.09.2001 - MGP, tag emlowen-V03-02-16
             Same as previous one, but test/GNUmakefile, G4ComptonTest.cc
             and G4ComptonTest.py for histograms and ntuples with Lizard 
             (by A. Pfeiffer)

19.09.2001 - MGP, tag emlowen-V03-02-15
             Same as previous one, but test/fluoTest with Particle gun

19.09.2001 - MGP, tag emlowen-V03-02-14
             Minor cosmetics w.r.t. the previous one (removed compilation 
             warnings)
             test/fluoTest with GPS

16.09.2001 - MGP, tag emlowen-V03-02-13
             Update to the fluorescence domain consistent with the
             new design (development by E. Guardincerri)
             Update to test/fluoTest (development by E. Guardincerri)

13.09.2001 - MGP, tag emlowen-V03-02-12
             Fix in G4CrossSectionHandler::Clear to remove an infinite loop
             occurring in test14

10.09.2001 - MGP, tag emlowen-V03-02-11
             Identical to emlowen-V03-02-10
             Restored a clean situation in the cvs head, removing all
             the code inconsistent with the design present in 
             emlowen-after-chep2001, resulting from a fault in the
             software process by a developer.

10.09.2001 - MGP, tag emlowen-after-chep2001
             Junk found in the repository 
             Tagged as an aid in the procedure of restoring a reasonable
             situation in the cvs head for future developments

29.08.2001 - MGP, tag emlowen-V03-02-10
             Major revision of G4LowEnergyCompton, G4LowEnergyRayleigh and
             G4LowEnergyGammaConversion: re-implementation according to
             the design iteration in the data domain
             Temporary re-implementation of G4LowEnergyPhotoElectricMG,
             without fluorescence yet

29.08.2001 - MGP, tag emlowen-V03-02-09
             Bug fix in G4CrossSectionHandler

29.08.2001 - MGP, tag emlowen-V03-02-08
             Cleared compilation warnings in G4AtomicTransitionManager
          
28.08.2001 - G.Cosmo, tag emlowen-V03-02-07
             Fixed mess with tag names

27.08.2001 - STT, tag emlowen-V03-02-06
 
20.08.2001 - MGP, tag emlowen-V03-02-05
             Added files resulting from design iteration in the data domain   

20.08.2001 - MGP, tag emlowen-V03-02-04
	     Same as emlowen-V03-02-02 + bug fix by V.I. described below

18.08.2001 - V.Ivanchenko fix energy conservation bugs for small
             range cuts in G4LowEnergyIonisation.cc

30.07.2001 - MGP, tag emlowen-V03-02-03
             First step of design iteration in fluorescence (files
             contributed by E. Guardincerri, G4AtomicShell and 
             G4AtomicTransitionManager) + related unit test

30.07.2001 - MGP, tag emlowen-V03-02-02
             Fix to GammaConversion by F. Longo

30.07.2001 - MGP, tag emlowen-V03-02-01
             Added modifications by V.I. listed below (13.07.2001),
             on top of previous tag

30.07.2001 - MGP, tag emlowen-V03-02-00
             Same as emlowen-V03-01-19, with liability disclaimer added

13.07.2001 - V.Ivanchenko remove comments with Rogue Wave 
             fix a problem of continuity of ion effective charge

18.06.2001 - MGP, tag emlowen-V03-01-19
             Same as emlowen-V03-01-18, with corrections by S. Chauvie
             to recover from modifications listed below
	     Quantum oscillator model is applied to all materials, as it
             has been since Geant4 3.0 release
             Contains also updates to G4StoppingPowerTest
             
18.06.2001 - MGP, tag emlowen-V03-01-18
             Same as emlowen-V03-01-17, with a bug fix to 
             G4LowEnergyPolarizedCompton by F. Longo and G. Depaola

07.06.2001 - Add printout to G4hLowEnergyIonisation + clean up (V.I.)
             Oscillator model is applied only for 6 materials (V.I.)

05.06.2001 - MGP, tag emlowen-V03-01-17
             Fix in G4QAOLowEnergyLoss by S. Chauvie of bugs introduced
             with the changes below    
             Also fixes in unit tests related to hadron ionisation         

01.06.2001 - V.Ivanchenko change G4QAOLowEnergyLoss: materials
             search by Z not name, validity range down to 5 keV,
             fix sign of the Barkas term

28.05.2001 - MGP, tag emlowen-V03-01-16
             Corrected typo involuntarily introduced into a public m.f.
 
25.05.2001 - MGP, tag emlowen-V03-01-15
             Added protections in G4LowEnergyPolarizedCompton (MGP)
             Improved comments in hadron/ion classes (V.I.)
             Improved code style in e/photon classes (MGP)

24.05.2001 - MGP, tag emlowen-V03-01-14
             Modified G4LowEnergyPolarizedCompton to inherit from
             G4VDiscreteProcess
    
23.05.2001 - MGP, tag emlowen-V03-01-13
             Modifications in G4LowEnergyIonisation and G4eLowEnergyLoss 
             by V.Ivanchenko:
             calculation of range directly from RangeTable;
             calculation of MeanFreePath from LambdaTable;
             improvement in the kinematics of delta-ray production

23.05.2001 - MGP, tag emlowen-V03-01-12
             Minor fix in G4hLowEnergyIonisation by V.Ivanchenko

23.05.2001 - MGP, tag emlowen-V03-01-11
             Cleaned up test macro names; minor update to G4MeanFreePathTest.cc
             minor changes in hTest histograms

23.05.2001 - V.Ivanchenko
             G4LowEnergyIonisation and G4eLowEnergyLoss changed:
             direct method of range table calculation;
             MeanFreePath is calculated from lambda table;
             kinematics of delta-ray production improved;
             minor fix in G4hLowEnergyIonisation.

22.05.2001 - MGP, tag emlowen-V03-01-10
             Bug fix in G4QAOLowEnergyLoss.cc

22.05.2001 - MGP, tag emlowen-V03-01-09
             Same as emlowen-V03-01-08, with further modifications to hTest

22.05.2001 - MGP, tag emlowen-V03-01-08
  	     Same as emlowen-V03-01-07, with in addition:
             - new unit tests (G4hTestLossTableProduction, G4MeanFreePathTest)
             - modifications to hTest
             - test macros renamed to be more easily identifiable

11.05.2001 - MGP, tag emlowen-V03-01-07
             Removed more compilation warnings in ANSI strict mode

11.05.2001 - MGP, tag emlowen-V03-01-06
             Same as emlowen-V03-01-04, with minor modification on hTest 
             by V. Ivanchenko

11.05.2001 - MGP, tag emlowen-V03-01-05
             Same as emlowen-V03-01-04, with a new unit test by V. Ivanchenko

10.05.2001 - V.Ivanchenko
             Removed compilation warnings in ANSI strict mode

08.05.2001 - MGP, tag emlowen-V03-01-04
             Removed compilation warnings in ANSI strict mode

07.05.2001 - MGP, tag emlowen-V03-01-03
             Removal of RW remnants, moved to STL containers

07.05.2001 - MGP, tag emlowen-V03-01-02
             Same as emlowen-V03-01-01, with some improvements in tests

02.05.2001 - MGP, tag emlowen-V03-01-01
             Same as emlowen-V03-01-00, with a first implementation of 
             a full suite of unit tests for electrons and photons

02.05.2001 - MGP, tag emlowen-V03-01-00
             Same as emlowen-V03-00-00, with minor new functionalities in 
             test/G4BremsstrahlungTest and G4eIonisationTest, and a new
             test/G4PhotoelectricTest unit test

24.04.2001 - V.Ivanchenko remove all references to RogueWave vectors

24.04.2001 - V.Ivanchenko reorganize and update hTest
 
05.02.2001 - G.Cosmo, tag emlowen-V03-00-00
             Migration to STL for G4DataVector and G4OrderedTable:
             o Removed obsolete class G4Data. G4DataVector is now used instead.
             o Modified files:
               G4LowEnergyBremsstrahlung[.hh.icc.cc], G4FirstLevel.hh,
               G4LowEnergyGammaConversion[.hh.cc], G4LowEnergyIonisation[.hh.cc],
               G4LowEnergyPhotoElectric[.hh.cc], G4LowEnergyRayleigh[.hh.cc],
               G4LowEnergyCompton[.hh.cc], G4LowEnergyUtilities[.hh.cc].

14.12.2000 - G.Cosmo, tag emlowen-V02-00-23
             Removed inclusion of CLHEP/String/Strings.h from G4LowEnergyUtilities.cc.

22.11.2000 - MGP, tag emlowen-V02-00-22
             Yang and Chu fluctuation models applied for positive
             charged ions only

23.11.2000 - Ion energy fluctuations only for charge>0
             V.Ivanchenko

22.11.2000 - MGP, tag emlowen-V02-00-21
             Includes bug fix to electron energy fluctuations 
             Compatible with electromagnetic/utils V02-00-04 tag, that has
             been finally accepted by STT

22.11.2000 - Bug fixed in electron energy fluctuations
             V.Ivanchenko

21.11.2000 - MGP, tag emlowen-V02-00-20
	     Same as emlowen-V02-00-18, Vladimir's fix to energy fluctuations
             (All this duplication of emlowen tags is due to the fact that the 
             electromagnetic/utils tag with the interface updates contains
             also bug fixes and new features, and such tag has not passed
             system testing yet)

21.11.2000 - MGP, tag emlowen-V02-00-19
	     Same as emlowen-V02-00-17, Vladimir's fix to energy fluctuations

21.11.2000 - Bug fixed in hadron/ion energy fluctuations
             V.Ivanchenko

16.11.2000 - MGP, tag emlowen-V02-00-18
             Same as emlowen-V02-00-16, with on top modifications to
             G4LowEnergyUtilities to replace the obsolete HepString 
             with G4String in several places

16.11.2000 - MGP, tag emlowen-V02-00-17
             Same as emlowen-V02-00-15, with on top modifications to
             G4LowEnergyUtilities to replace the obsolete HepString 
             with G4String in several places

05.11.2000 - MGP, tag emlowen-V02-00-16
             Remove the temporary const cast introduced with emlowen-V02-00-08
             Co-works with Michel's electromagnetic/utils utils-V02-00-03 tag
             
05.11.2000 - MGP, tag emlowen-V02-00-15
             Includes bug fixes and other modifications by V. Ivanchenko
             listed below

05.11.2000 - Bugs fix in G4QAOLowEnergyLoss.cc : inserted at previous
             edition, name "Aluninum", de/dx at E=2 MeV, and
             more correct charge calculation
           - New method to calculate ranges via de/dx table and
             remove dynamic binning in G4hLowEnergyLoss.cc
           - More precise calculation of ionisation ranges for
             KineticEnergy<MinKineticEnergy in G4hLowEnergyIonisation.cc
             V. Ivanchenko

03.11.2000 - MGP, tag emlowen-V02-00-14
             Fix by V. Ivanchenko to remove the cause of instability
             of hadron ionisation on different platforms, related to the last
             step
             Set MinKineticEnergy = LowestKineticEnergy = 10eV
	     Results changed w.r.t. the previous version by 0.5% for protons, 
             1% for antiprotons and 2.8% for C12

03.11.2000 - Modification
             MinKineticEnergy=LowestKineticEnergy=10eV
             V. Ivanchenko

03.11.2000 - MGP, tag emlowen-V02-00-13
             Same as emlowen-V02-00-12, added comments for the generation of
             the Software Reference Manual 

31.10.2000 - MGP, tag emlowen-V02-00-12
             Including modifications by V. Ivanchenko since emlowen-V02-00-11
             listed below

23.10.2000 - 
             Clean up and update comments
             V. Ivanchenko

14.10.2000 - 
             Bug fix in nuclear stopping table name
             V. Ivanchenko

20.09.2000 - MGP, tag emlowen-V02-00-11
             Bug fix related to electron energy loss fluctuations by
             V. Ivanchenko

18.09.2000 - MGP, tag emlowen-V02-00-10
             Improvements to the readability of the code by V. Ivanchenko

17.09.2000 - MGP, tag emlowen-V02-00-09
             New features on antiproton ionisation by Stephane Chauvie:
             extension of the Quantum Harmonic Oscillator model to
             generic materials, calculation of oscillator strengths for 
             all elements
             Antiproton model also moved to be compliant with the new design
             iteration

16.09.2000 - MGP, tag emlowen-V02-00-08	
             Const cast in G4hLowEnergyIonisation (const G4Material* into
             G4Material*) to convert the previously _good_ LowE code 
             into bad one, but palatable to G4EnergyLossTables, that has 
             various member functions requiring a non-const G4Material* 
	     pointer in the arguments
             This modification was required to avoid compilation errors
             on DEC; it is meant to be temporary
             The affected pointers SHOULD BE REVERTED TO CONST 
             AS SOON AS POSSIBLE, after agreement with the 
             G4EnergyLossTables author

16.09.2000 - MGP, tag emlowen-V02-00-07
	     Fix in G4hICRU49He::StoppingPower - a1 changed into e1 (typo?) 
	     to remove compilation problems on DEC (uninitialized variable)
             Fix in G4hLowEnergyLoss, eliminated two protected variables
             G4Proton* theProton and G4AntiProton* theAntiProton 
             to revove compilation problems on DEC (hiding)

16.09.2000 - MGP, tag emlowen-V02-00-06
	     Modifications by V.I. in hadron classes (renaming of classes
             for better understanding of the code)

05.09.2000 - MGP, tag emlowen-V02-00-05
	     Fixes to remove warnings (hiding member functions and 
             data members) in hadron classes 

04.09.2000 - MGP, tag emlowen-V02-00-04
             Same as emlowen-V02-00-03, with V.I.'s new implementations
	     and fixes (see below, July-August 2000)

04.09.2000 - MGP, tag emlowen-V02-00-03
             Same as emlowen-V02-00-02, with Gabriele's fixes 
             (see below, 03.08.2000)

22.08.2000 - V.Ivanchenko: A bug in Nuclear Stopping Power was fixed.
             The calculation of step limit for low energy
             hadrons/ions is upgraded.
             The Barkas and Bloch corrections are introduced
             for ions "on fly"

18.08.2000 - V.Ivanchenko: TRIM1985 model have been implemented
             A bug in GetConstrain method for hadrons/ions is fixed

18.08.2000 - V.Ivanchenko: two additional models of ions energy 
             loss fluctuations have been implemented

10.08.2000 - V.Ivanchenko: Old bug in Fluctuations of Electronic
             energy losses of hadrons and ions are fixed

04.08.2000 - V.Ivanchenko: Fluctuations of Nuclear Stopping Powers are
             Energy losses of hadrons and ions are implemented

03.08.2000 - G.Cosmo
             Fixes to allow events' reproducibility:
             G4LowEnergyGammaConversion.cc: changed usage of RandFlat::shootBit() to
                                            RandBit::shootBit().
             G4VeLowEnergyLoss.cc, G4hLowEnergyLoss.cc: changed RandGauss to
                                            G4RandGauss.

02.08.2000 - V.Ivanchenko: Energy losses of hadrons and ions are redesigned,
             a lot of new classes are created. New unit test is designed
             as well (G4hTestStoppingPower).

29.07.2000 - MGP, tag emlowen-V02-00-02
             Added theta to ntuples in G4BremsstrahlungTest

18.07.2000 - MGP, tag emlowen-V02-00-01
             V.Ivanchenko: bug fix in G4hLowEnergyIonisation in AlongStepDoIt

11.07.2000 - MGP, tag emlowen-V02-00-00
             Improvements in G4BremsstrahlungTest and G4eIonisationTest

24.06.2000 - MGP, tag emlowen-V01-01-22
             Modification to hTest G4Ion... classes by V. Ivanchenko to 
             fix crash on exit on Linux

22.06.2000 - MGP, tag emlowen-V01-01-21
	     MGP: Bug fix in G4VeLowEnergyLoss (calculation of fluctuations);
	     correction to prevent log of negative argument
             Fixes problems with test14 in system testing on HP 
	     To be further verified 

22.06.2000 - MGP, tag emlowen-V01-01-20
	     Minor improvements in test/G4BremsstrahlungTest and
	     and test/G4eIonisationTest
	     Cosmetics (found $ tag $ in many header files, where does it
             come from?)

20.06.2000 - MGP, tag emlowen-V01-01-19
	     Fixed printout in test/G4eIonisationTest

20.06.2000 - MGP, tag emlowen-V01-01-18
	     Two new unit tests created by MGP: test/G4BremsstrahlungTest
             and test/G4eIonisationTest

24.05.2000 - MGP, tag emlowen-V01-01-17
             Modifications to G4QAOLowEnergyloss and G4hLowEnergyIonisation
	     by Stephane Chauvie: physics fixes
	     Modifications to G4QAOLowEnergyloss and G4hLowEnergyIonisation
	     by MG Pia:	fixes to the private interface,
                        fixes to remove compilation warnings
                        added protections
                        proper code indentation to improve legibility
             Reorganization of the test directory by Petteri Nieminen:
			content of eUnitTests/ moved to ePhotonIntegration/
                        (indeed they were not unit tests)
			content of validation/ moved to aluminumtest/
	     Corrections by MG Pia to GNUmakefiles in test/ subdirectories 
             TestEm6, TestP, eUnitTests and validation are obsolete
             directories, still in the repository but not to be used

23.05.2000 - MGP, tag emlowen-V01-01-16
             New G4QAOLowEnergyloss class by Stephane Chauvie for
             antiproton energy loss model
	     Modifications to G4hLowEnergyIonisation for the new
             antiproton models
	     Physics extension to lower energies for antiprotons for a 
             set of materials
	     New test/hTest for integration/physics testing of hadrons/ions
             (was previously TestEm6)

25.05.2000 - Stephane Chauvie added class for energy loss of antiprotons
             G4QAOLowEnergyloss + modifications in G4hlowEnergyIonisation 

22.05.2000 - MGP, tag emlowen-V01-01-15
	     Modifications in G4VhEnergyLossModel.hh 

19.05.2000 - MGP, tag emlowen-V01-01-14
	     Includes typo correction in G4VhEnergyLossModel.hh

 8.05.2000 - MGP, tag emlowen-V01-01-13
	     Includes minor modifications in G4VhEnergyLossModel.hh

 7.05.2000 - MGP, tag emlowen-V01-01-12
             Includes the G4VhEnergyLossModel abstract class,
             as part of the design iteration in the hadronic domain

 7.05.2000 - MGP, tag emlowen-V01-01-11
             Includes Francesco Longo's fix of missing units in 
	     G4LowEnergyGammaConversion.cc

 7.05.2000 - MGP, tag emlowen-V01-01-10
             Includes Vladimir's test/TestEm6 and test/TestP directories
             requires removing two (!) duplicate TestEm6 directories
             elsewhere
             Includes Stephane's unit tests  G4hLETestLossTable.cc
             and G4hLETestAlongPostStep.cc
              
19.04.2000 - MGP, tag emlowen-V01-01-09
             same as emlowen-V01-01-08, with modifications by V.L. for
             first implementation of continuous energy loss in 
             G4LowEnergyBremsstrahlung

18.04.2000 - MGP, tag emlowen-V01-01-08
	     same as emlowen-V01-01-06,
             with modification to G4LowEnergyBremsstrahlung.cc to correct
             error introduced by V.L

18.04.2000 - MGP, tag emlowen-V01-01-07
             same as emlowen-V01-01-05 
             (disregarding modifications in emlowen-V01-01-06),
             with modification to G4LowEnergyBremsstrahlung.cc to correct
             error introduced by V.L. 

18.04.2000 - MGP, tag emlowen-V01-01-06
             includes Veronique's modifications to 
		G4LowEnergyIonisation.hh
		G4LowEnergyIonisation.icc
		G4LowEnergyIonisation.icc
		G4eLowEnergyLoss.cc
		G4G4LowEnergyPhotoElectric.cc
             for integration of cross sections, float/G4double conversions
             and corrections of fluorescence transition probabilities 
	     to take into account non-radiative transitions
             (no Auger electron simulated yet)


04.04.2000 - MGP, tag emlowen-V01-01-05
             removed dependency on standard category (G4eEnergyLoss)

04.04.2000 - MGP, tag emlowen-V01-01-04
             tag Vladimir's and Stephane's modifications for antiprotons

03.04.2000 - Vladimir Ivanchenko and Stephane Chauvie
             1) Linearity into Barkas effect and nuclear stopping power
                for antiprotons

02.04.2000 - MGP, tag emlowen-V01-01-03
             tag V.L.'s modifications to G4LowEnergyIonisation (units)

02.04.2000 - MGP, tag emlowen-V01-01-02
             tag V.L.'s fix of typo in G4LowEnergyGammaConversion

02.04.2000 - MGP, tag emlowen-V01-01-01
             tag V.I.'s modifications, 31.03.2000 

31.03.2000 - Vladimir Ivanchenko update 
             1) G4hLowEnergyIonisation.cc limitation DeltaCut > Eexc
                is insert in dedx, cross section calculation and sampling
             2) G4hLowEnergyLoss.cc is creating in the lowenergy as a
                klon of G4hEnergyLoss.cc
             3) Spin 1/2 and spin 1 corrections are inserted is cross
                section calculation, cross section sampling, de/dx
             4) IfAplicable check lepton number
                
21.01.2000 - Vladimir Ivanchenko update 
             1) G4hLowEnergyIonisation.cc Barkas effect calculation
                and inicialisation 
             2) G4ionLowEnergyIonisation.cc remove double deleting of
                MeanFreePath Table

21.01.2000 - create by Michel Maire


